// ROOT script for ESAF automatic documentation
// $Id: makehtml.C 2119 2005-09-25 18:27:06Z naumov $
// A.Thea, D.Naumov created Jun 17 2004
// makehtml: creates RES automatic documentation
// D.Naumov updated for RES 05.01.2005
void makehtml(){
    
    gROOT->ProcessLine(".x loadlibs.C");
    Long_t id, flags, modtime;
	Long64_t size;
		
    if ( ( gSystem->GetPathInfo("ListOfClasses", &id, &size, &flags, &modtime) == 1 ) ||
		 ( gSystem->GetPathInfo("ListOfPaths", &id, &size, &flags, &modtime) == 1 ) ) {

        cout << "ListOfClasses or ListOfPaths missing." <<
                " Run \"make doc\" from main RES directory" << endl;
        return;
    }
	
    ifstream classlist, pathlist;

    classlist.open("ListOfClasses");
    pathlist.open("ListOfPaths");

    TString dummy;
    TString path;

    // build path
    while ( kTRUE ) {
        dummy.ReadLine( pathlist, kTRUE );
        if (pathlist.eof()) break;
        path += dummy+":";
    }

    path.Remove(path.Length()-1);

    TList* classnames = new TList; 
    // build classlist
    while ( kTRUE ) {
        dummy.ReadLine( classlist );
        if (classlist.eof()) break;
        classnames->Add(new TObjString(dummy));
    }

    THtml *html = new THtml();
    html->SetSourceDir(path);

    TIter next(classnames);
    TObjString* obj = 0;
    while( obj = (TObjString*) next()) {
        html->MakeClass(obj->String());
    }

    html->MakeIndex(); 
    delete html;

    classnames->Delete();

}
