// $Id: MakePixelMapPhotonFile.C 2903 2011-05-11 11:27:43Z naumov $
// Author: A.Thea   2005/04/19

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: MakePixelMapPhotonFile                                               *
 *  Package: Macros                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

/* #include "EsafConfigurable.hh"
#include "Config.hh"
#include "EsafMsgSource.hh"
#include "EsafMsgDispatcher.hh"
#include "TString.h"
#include "PixelMapBuilder.hh"
*/

//______________________________________________________________________________
void MakePixelMapPhotonFile( const char* name=0 ) {
    //
    // Builds the pixlemap photons file according the current config
    //

    if ( name ) {
        TString key = "PixelMapBuilder";
        TString value = key+".fRootFileName = "+name;
        Config::Get()->AddUserDefinition(std::string(key),std::string(value));
    }
    EsafMsgDispatcher::Get()->SetScreenSeverity(EsafMsg::Debug);

    PixelMapBuilder builder;
    Long64_t n = builder.Conf()->GetNum("PixelMapBuilder.fNumPhotons");
    string filename = builder.Conf()->GetStr("PixelMapBuilder.fRootFileName");
//    builder.SetSaveHistograms((filename+"_histos").c_str()); // DN save histos
//     builder.MakePhotonsFile(filename.c_str(),n);
//    EGViewer *display = new EGViewer;
//    builder.SetDisplay(display);

    builder.MakeMap(filename.c_str(),(filename+"map").c_str());

//     builder.OpenRoot(name);
//     builder.Go();
//     builder.CloseRoot();
}

//______________________________________________________________________________
void MakeUserPixelMapPhotonFile( const char* name=0, const char* usercfg=0 ) {
    //
    // Builds the pixlemap photons file according the user config
    //

    if ( usercfg ) {
        cout << "User config file " << usercfg << " loaded" << endl;
        Config::Get()->LoadUserConfig(usercfg);
    }

    MakePixelMapPhotonFile( name );
}
