// $Id: PhP2PhPRoot.C 2031 2005-07-10 19:54:57Z thea $
// Author: A.Thea 2005/07/05

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: PhP2PhPRoot                                                          *
 *  Package: Macros                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

void PhP2PhPRoot( const char* in, const char* out, Double_t r=3000 ) {

    Config::Get()->Reset();

    EEvent* ev =  new EEvent();
    EEvent::SetCurrent(ev);

    std::string key;
    std::string value;

    key = "FileUnisimLightToEuso";
    value = key+".fFileName="+in;
    Config::Get()->AddUserDefinition(key,value);

    value = key+".fFirstEvent=0";
    Config::Get()->AddUserDefinition(key,value);

    key = "PhPToRootFileDetector";
    value = key+".fFileName="+out; 
    Config::Get()->AddUserDefinition(key,value);

    value = key+".fRadius="+Form("%f",r);
    Config::Get()->AddUserDefinition(key,value);

    LightToEuso* light = new FileUnisimLightToEuso();
    Detector* det = new PhPToRootFileDetector();

    while( kTRUE ) {
        PhotonsOnPupil* php = light->Get( det->GetGeometry() );

        if (!php) break;

        det->Reset();
        det->Get(php);
    } 

    delete det;
    delete light;
    delete ev;
}
        
