// $Id: EsafMsgSource.hh 2804 2008-10-09 12:10:06Z biktem $
// Author: M. Pallavicini    Sep, 24 2004

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: EsafMsgSource                                                        *
 *  Package: Base                                                            *
 *  Coordinator: Marco.Pallavicini                                           *
 *                                                                           *
 *****************************************************************************/

#ifndef __ESAFMSGSOURCE_HH_
#define __ESAFMSGSOURCE_HH_

#include <string>
#include "euso.hh"
#include "EsafMsg.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// EsafMsgSource                                                              //
//                                                                            //
// ESAF Message Source                                                        //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

class EsafMsgSource {
protected:

    EsafMsgSource();
    // default ctor

    EsafMsgSource(const EsafMsgSource& );

public:
    virtual ~EsafMsgSource() {}
    // dtor

    EsafMsg& Msg( EsafMsg::MsgSeverity ) const;
    // prepare message and returns it for writing

    void MsgForm( EsafMsg::MsgSeverity, const char *fmt, ...) const;
//     void MsgForm( EsafMsg::MsgSeverity, const char *fmt) const;
    // prepare and send a message with printf syntax

    inline void Dispatch() const { fMsg.Dispatch(); }
    // dispatch message

    inline void FatalError( const string& ) const;

    inline void SetSender(const char* s) {fMsg.SetSender(s);}
    //

private:

    mutable EsafMsg fMsg;
    // the message

public:
    ClassDef(EsafMsgSource,0)
};


inline void EsafMsgSource::FatalError( const string& errmsg ) const {
    Msg(EsafMsg::Panic)  << errmsg  << MsgDispatch;
}

#endif  /* __ESAFMSGSOURCE_HH_ */
