// ESAF : Euso Simulation and Analysis Framework
// $Id: EusoTimeOrbit.hh 1003 2004-09-13 21:46:13Z thea $
// M. Pallavicini created May,  7 2003
// description of absolute time and ISS orbit

#ifndef __EUSOTIMEORBIT_HH_
#define __EUSOTIMEORBIT_HH_

#include "euso.hh"
#include <time.h>
#include <string>

class EusoTimeOrbit {
public:
    // dtor
    virtual ~EusoTimeOrbit();
    
    // singleton
    static EusoTimeOrbit *Get();

    // run date
    const string& GetRunDate();
    void SetRunDate(time_t* pT=NULL);    // UTC date stored in time_t
    void SetRunDate(const string& );     // UTC date as string dd-mmm-yyyy
    void SetRunDate(const char* );       // same  
    
    // event UTC time
    const string& GetEventTime();
    void SetEventTime(time_t* pT=NULL);  // UTC time as time_t
    void SetEventTime(const string& );   // UTC time as hh:mm:ss
    void SetEventTime(const char* );     // same
     

    // ISS position
    // to be done (returns ISS position at a given time)
    // possibly, it may need a data base or an analytic function
    
private:
    // ctor
    EusoTimeOrbit();
    
    // singleton
    static EusoTimeOrbit *me;

    // local string
    string fStringBuffer;
    
    // only one time and date in a UTC based time_t
    time_t fTime;
    ClassDef(EusoTimeOrbit,0)
};

#endif  /* __EUSOTIMEORBIT_HH_ */

