// ESAF : Euso Simulation and Analysis Framework
// $Id: StringsFileParser.hh 1608 2005-03-21 17:24:53Z thea $
// Daniel De Marco created Jan, 28 2002

#ifndef __STRINGSFILEPARSER_HH_
#define __STRINGSFILEPARSER_HH_

#include <string>
#include <list>
#include <iostream>
#include <fstream>

#include "euso.hh"
#include "EsafMsgSource.hh"

class StringsFileParser : public EsafMsgSource {
public:
    StringsFileParser(const string &fn);
    virtual ~StringsFileParser();

    list<list<string> > &GetLines();

    inline virtual Bool_t IsZombie() { return fZombie; } 

protected:
    inline virtual void MakeZombie() { fZombie = kTRUE; }

    list<list<string> > fLines;
    string fFileName;

    Bool_t fZombie;
    
    ClassDef(StringsFileParser,0)
};

inline list<list<string> > &StringsFileParser::GetLines() {
    return fLines;
}
#endif  /* __STRINGSFILEPARSER_HH_ */

