// ESAF : Euso Simulation and Analysis Framework
// $Id: EShowerHistoPainter.hh 2819 2009-03-13 11:48:16Z naumov $
// Author: Naumov Dmitry   Jul, 26 2004

#ifndef __ESHOWERHISTOPAINTER_HH__
#define __ESHOWERHISTOPAINTER_HH__

//#include "euso.hh"
#include "EAnimator.hh"
#include "TSeqCollection.h"

class EShower;
class EGeometry;
class EDetector;
class TH1F;
class TTimer;

/*******************************************************************************
 *
 * EShowerHistoPainter: this class plots and animates a set of standard
 * histograms describing the shower development.
 *
 ******************************************************************************/

class EShowerHistoPainter : public EAnimator {
public:
    EShowerHistoPainter( EShower*, const EGeometry*, EDetector* );
    virtual ~EShowerHistoPainter();

    virtual void Draw(Option_t *opt="");

    void Build();

    virtual void NextFrame();

    TH1F* GetTimeHisto(const char*, const char* =0);
    TH1F* GetGtuHisto(const char*, const char* =0);
    TH1F* GetAltHisto(const char*, const char* =0); 

    TSeqCollection* GetListOfHistos() {return fHistos;}

private:

    void UpdateHistos();

    TSeqCollection *fHistos;

    EShower         *fShower;
    const EGeometry *fGeometry;
    EDetector       *fDetector;
    Double_t        *fTimeBins;
    Double_t        *fAltBins; 
    Double_t        fNeMax;
    Double_t        fAgeMax;
    Double_t        fDepthMax;
    Double_t        MinGtu;
    Double_t        MaxGtu;
    Int_t           GtuBins;
    ClassDef(EShowerHistoPainter,1);
};

#endif  /* __ESHOWERHISTOPAINTER_HH__ */

