// $Id: OutputRenameDlg.cc 2218 2005-10-18 23:17:30Z thea $
// dialog to allow user to change detector
// parameters
// 15-03-2002 M. Pallavicini created

#include "OutputRenameDlg.hh"
#include "SimuApplication.hh"
#include "TGButton.h"
#include "Config.hh"
#include "TGLabel.h"

ClassImp(OutputRenameDlg)

//______________________________________________________________________________
OutputRenameDlg::OutputRenameDlg(const TGWindow* p, const TGWindow *main)
    : TGTransientFrame( p, main, 500,350) {

        fFrame = new TGHorizontalFrame(this,60,20,kFixedWidth);
        fOK = new TGTextButton(fFrame,"&OK",1);
        fOK->Associate( this );
        fCancel = new TGTextButton(fFrame,"&Cancel",2);
        fCancel->Associate( this );

        fL1 = new TGLayoutHints(kLHintsTop|kLHintsLeft|kLHintsExpandX,2,2,2,2);
        fL2 = new TGLayoutHints(kLHintsBottom|kLHintsRight,2,2,5,1);

        fFrame->AddFrame( fOK, fL1 );
        fFrame->AddFrame( fCancel, fL1 );
        fFrame->Resize(150,fOK->GetDefaultHeight());

        AddFrame( fFrame, fL2 );

        MapSubwindows();
        Resize( 400,300 );
        Window_t wd;
        int ax,ay;
        gVirtualX->TranslateCoordinates( main->GetId(), GetParent()->GetId(),
                (((TGFrame*)main)->GetWidth()-500)>>1,
                (((TGFrame*)main)->GetWidth()-350)>>1, ax, ay, wd );
        Move(ax,ay);
        SetWindowName("Output files names");
        MapWindow();
    }

//______________________________________________________________________________
OutputRenameDlg::~OutputRenameDlg() {
    delete fL1;
    delete fL2;
    delete fFrame;
    delete fOK;
    delete fCancel;
}

//______________________________________________________________________________
void OutputRenameDlg::CloseWindow() {
      delete this;
}

//______________________________________________________________________________
Bool_t OutputRenameDlg::ProcessMessage( Long_t msg, Long_t p1, Long_t p2 ) {
  switch (GET_MSG(msg ) ) {
    case kC_COMMAND:
        switch (GET_SUBMSG(msg)) {
            case kCM_BUTTON:
                switch(p1) {
                    case 1:            // OK button pressed
                        RetrieveData();
                        printf("\nTerminating dialog: %s pressed\n", (p1 == 1) ? "OK" : "Cancel");
                        CloseWindow();
                        break;
                    case 2:            // cancel button pressed
                        printf("\nTerminating dialog: %s pressed\n", (p1 == 1) ? "OK" : "Cancel");
                        CloseWindow();
                        break;
                    default:
                        break;
                } 
                break;
            default:
                break;
        }
      break;
    default:
      break;
  }

  return kTRUE;
}

//______________________________________________________________________________
void OutputRenameDlg::RetrieveData() {
}



