// $Id: RecoPhotonOnPupilData.hh 1959 2005-06-16 14:55:11Z stutz $
// Author: Anne Stutz   2005/06/09

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: RecoPhotonOnPupilData                                                           *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __RECOPHOTONONPUPILDATA_HH__
#define __RECOPHOTONONPUPILDATA_HH__

#include "euso.hh"


////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// RecoPhotonOnPupilData                                                                 //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class RecoPhotonOnPupilData {
public:
    // ctor
    RecoPhotonOnPupilData(UChar_t type, UChar_t history, Float_t wl, Float_t time);

    // dtor
    virtual ~RecoPhotonOnPupilData();

    // Getters
    inline UChar_t GetType() const {return fType;}
    inline UChar_t GetHistory() const {return fHistory;}
    inline Float_t GetWl() const {return fWl;}
    inline Float_t GetTime() const {return fTime;}

private:
    UChar_t fType;               // photon type
    UChar_t fHistory;            // how photon has been created
    Float_t fWl;                 // wavelength
    Float_t fTime;               // date on pupil since first interaction
    
    friend class RootInputModule;
    ClassDef(RecoPhotonOnPupilData,0)
};

#endif  /* __RECOPHOTONONPUPILDATA_HH__ */

