// ESAF : Euso Simulation and Analysis Framework
// $Id: RecoPixelData.hh 1012 2004-09-14 12:40:23Z naumov $
// Marco Pallavicini created Nov, 18 2003
// front end pixel data; right now there is no difference with 
// macrocell data but there are no ghosts in front end 
// the class is identical even though we keep it different to allow
// future developments if needed

#ifndef __RECOPIXELDATA_HH_
#define __RECOPIXELDATA_HH_

#include "euso.hh"
#include "RecoCellHit.hh"

class RecoPixelData : public RecoCellHit {
public:
    // ctor
    RecoPixelData(Int_t, Int_t, Int_t);

    // dtor
    virtual ~RecoPixelData();

    // getters
    inline Float_t GetTheta() const { return fTheta; }
    inline Float_t GetThetaSigma() const { return fThetaSigma; }
    inline Float_t GetPhi() const { return fPhi; }
    inline Float_t GetPhiSigma() const { return fPhiSigma; }
    inline Int_t GetMacroCellId() const { return fMacroCellId; }
        
private:
    Float_t fTheta;
    Float_t fThetaSigma;
    Float_t fPhi;
    Float_t fPhiSigma;
    Int_t fMacroCellId;

    friend class RootInputModule;

    ClassDef(RecoPixelData,0)
};

#endif  /* __RECOPIXELDATA_HH_ */

