// $Id: RecoGlobalData.hh 2713 2006-06-06 12:28:46Z thea $
// Author:    2006/06/05

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: RecoGlobalData                                                       *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __RECOGLOBALDATA_HH__
#define __RECOGLOBALDATA_HH__

#include "euso.hh"
#include "RecoData.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// RecoGlobalData                                                             //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class RecoGlobalData : public RecoData {
public:
    RecoGlobalData( const string& name );
    virtual ~RecoGlobalData();

    virtual const string& GetName() const { return fDataName; }
    
    virtual void CleanMaps();

    virtual void SetIssuer( const string& name ) { fIssuer = name; }
    virtual const string& GetIssuer() const { return fIssuer; }
private:

    string fDataName;
    string fIssuer;
    
    ClassDef(RecoGlobalData,0)
};

#endif  /* __GLOBALDATA_HH__ */

