// ESAF : Euso Simulation and Analysis Framework
// A sequence is a specialized multiple module
// It runs different modules in sequence with some specialized behaviour
// For example, it can be very useful for iterative algorythms
// $Id: RecoSequence.hh 1112 2004-09-28 12:10:53Z thea $
// Marco Pallavicini created Oct, 16 2003

#ifndef __RECOSEQUENCE_HH_
#define __RECOSEQUENCE_HH_

#include <string>
#include <vector>

#include "euso.hh"
#include "RecoModule.hh"

class RecoSequence : public RecoModule {
public:
    // ctor
    RecoSequence( const string& );

    // dtor
    virtual ~RecoSequence();

    EsafConfigClass(Reco,RecoSequence)

protected:
    virtual void CreateSequence() = 0;

private:
    vector<RecoModule*> fModules;

    ClassDef(RecoSequence,0)
};

#endif  /* __RECOSEQUENCE_HH_ */

