// ESAF : Euso Simulation and Analysis Framework
// $Id: TestInputModule.hh 2637 2006-03-29 14:29:36Z thea $
// Marco Pallavicini created Oct, 16 2003

#ifndef __TESTINPUTMODULE_HH_
#define __TESTINPUTMODULE_HH_

#include "euso.hh"
#include "InputModule.hh"
class RecoRootEvent;

class TestInputModule : public InputModule {
public:
    // ctor
    TestInputModule(const string&);

    // dtor
    virtual ~TestInputModule();

    // returns one event until event source is empty
    virtual RecoEvent* GetEvent( const char* = 0);
    
    // delete last returned event
    virtual void DestroyEvent();
    
    // init data source
    virtual Bool_t Init();

    // close data source
    virtual Bool_t Done();
    
    // save root output
    virtual Bool_t SaveRootData( RecoRootEvent* ) {return kTRUE;}

private:
    Int_t fCounter;
    ClassDef(TestInputModule,0)
};

#endif  /* __TESTINPUTMODULE_HH_ */

