// ESAF : Euso Simulation and Analysis Framework
// $Id: EusoCluster.cc 2717 2006-06-07 07:53:42Z pesce $
// R. Pesce created Jan, 23 2004

#include <stdexcept>
#include "EusoCluster.hh"

ClassImp(EusoCluster)

//______________________________________________________
EusoCluster::EusoCluster() {
    //
    // ctor
    //

    fNumPoints = 0;
    fSlopeTheta = 0;
    fOffsetTheta = 0;
    fAbsoluteDeviationTheta = 0;
    fSlopePhi = 0;
    fOffsetPhi = 0;
    fAbsoluteDeviationPhi = 0;
    fThetaMin = 0;
    fThetaMax = 0;
    fPhiMin = 0;
    fPhiMax = 0;
    fGtuMin = 0;
    fGtuMax = 0;
    fThreshold = 0;
    fIsFitted = kFALSE;
    fPixelId.clear();
}

// dtor
EusoCluster::~EusoCluster() {
    //fPixelId.clear();
}

// add a point
void EusoCluster::AddPoint( Int_t id ) {
    fNumPoints++;
    fPixelId.push_back(id);
}

// get id of pixel (reference to vector fPixelData in RecoEvent)
const Int_t EusoCluster::GetPixelId( Int_t i) {
    if ( i>= 0 && i < fNumPoints ) {
        return fPixelId[i];
    } else {
        throw runtime_error("EusoCluster::GetPixelId out of index");
    }
}
