// $Id: EnergyFitUtils.hh 2370 2005-11-14 17:02:49Z naumov $
// Author: Dmitry.Naumov   2005/09/26

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: EnergyFitUtils                                                       *
 *  Package: Energy                                                          *
 *  Coordinator: Dmitry.Naumov                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __ENERGYFITUTILS_HH__
#define __ENERGYFITUTILS_HH__

#include "euso.hh"


////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// EnergyFitUtils                                                             //
//                                                                            //  
// This is a collection of fit functions                                      //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

Double_t Fit_Energy(Double_t *x, Double_t *par);
Double_t TimeDistr(Double_t *x, Double_t *par);
Double_t Background(Double_t *x, Double_t *par);
Double_t Saturation(Int_t pe);
Int_t    UnfoldSaturation(Int_t pe);
#endif  /* __ENERGYFITUTILS_HH__ */

