// $Id: RecoHeader.hh 1356 2005-01-05 13:08:21Z pesce $
// Author: R.Pesce   2005/01/04

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: RecoHeader                                                           *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __RECOHEADER_HH__
#define __RECOHEADER_HH__

#include "TObject.h"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// RecoHeader                                                                 //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class RecoHeader : public TObject {
public:
    RecoHeader();
    // ctor

    RecoHeader( const RecoHeader& );
    // copy ctor
    
    virtual ~RecoHeader();
    // dtor

    void Clear();
    // clear method

    virtual void Copy( TObject& ) const;
    // copy to a new object
    
    // setters
    inline void Set( Int_t n, Int_t r ) {fNum=n; fRun=r;}
    inline void SetNum( Int_t n )  { fNum = n; }
    inline void SetRun( Int_t r )  { fRun = r; }

    // getters
    inline Int_t GetNum() const { return fNum; }
    inline Int_t GetRun() const { return fRun; }

private:
    Int_t fNum;   // event number
    Int_t fRun;   // run number

    ClassDef(RecoHeader,1)
};

#endif  /* __RECOHEADER_HH__ */

