// ESAF : Euso Simulation and Analysis Framework
// $Id: RecoRootEvent.hh 2716 2006-06-07 07:51:34Z pesce $
// Dmitry V.Naumov created Jun, 21 2004

#ifndef __RECOROOTEVENT_HH_
#define __RECOROOTEVENT_HH_

#include <TObject.h>

#include "RecoTruth.hh"
#include "RecoHeader.hh"
#include "RecoClustering.hh"
#include "RecoTrackDirection.hh"
#include "RecoTrackDirection2.hh"
#include "RecoHmaxForProton.hh"
#include "RecoEnergy.hh"
#include "RecoProfile.hh"

class RecoRootEvent : public TObject {
public:
    // ctor
    RecoRootEvent();

    // dtor
    virtual ~RecoRootEvent();
    
    RecoTruth             &GetTruth()                    {return fTruth;}
    RecoHeader            &GetRecoHeader()               {return fHeader;}
    RecoClustering        &GetRecoClustering()            {return fClustering;}
    RecoTrackDirection    &GetRecoTrackDirection()       {return fTrackDirection;}
    RecoTrackDirection2   &GetRecoTrackDirection2()      {return fTrackDirection2;}
    RecoHmaxForProton     &GetRecoHmaxForProton()        {return fRecoHmaxForProton;}
    RecoEnergy            &GetRecoEnergy()               {return fRecoEnergy;}
    RecoProfile           &GetRecoProfile()              {return fRecoProfile;}
    
    void                   Clear();

private:
    RecoTruth             fTruth;
    RecoHeader            fHeader;
    RecoClustering        fClustering;
    RecoTrackDirection    fTrackDirection;
    RecoTrackDirection2   fTrackDirection2;
    RecoHmaxForProton     fRecoHmaxForProton;
    RecoEnergy            fRecoEnergy;
    RecoProfile           fRecoProfile;
    
    ClassDef(RecoRootEvent,1)
};

#endif  /* __RECOROOTEVENT_HH_ */

