// $Id: RecoClustering.cc 2736 2006-06-11 16:04:19Z pesce $
// Author:    2006/06/05

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: RecoClustering                                                           *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

//_____________________________________________________________________________
//
// RecoClustering
//
// <extensive class description>
//
//   Config file parameters
//   ======================
//
//   <parameter name>: <parameter description>
//   -Valid options: <available options>
//

#include "RecoClustering.hh"

ClassImp(RecoClustering)

//_____________________________________________________________________________
RecoClustering::RecoClustering() {
    //
    // Constructor
    //
    Clear();
}

//_____________________________________________________________________________
RecoClustering::~RecoClustering() {
    //
    // Destructor
    //
}

//_____________________________________________________________________________
RecoClustering::RecoClustering( const RecoClustering& other ) {
    //
    // Copy constructor
    //
    other.Copy( *this );
}

//_____________________________________________________________________________
void RecoClustering::Copy( TObject& other ) const {
    //
    // Copy to a new object
    //
    TObject::Copy( other );

    ((RecoClustering&)other).fNumPoints = fNumPoints;
    ((RecoClustering&)other).fSignalFraction = fSignalFraction;
    ((RecoClustering&)other).fSigFracOverThresh = fSigFracOverThresh;
    ((RecoClustering&)other).fContamination = fContamination;
    ((RecoClustering&)other).fContaminationInCluster = fContaminationInCluster;
    ((RecoClustering&)other).fAbsDevMainTheta = fAbsDevMainTheta;
    ((RecoClustering&)other).fAbsDevMainPhi = fAbsDevMainPhi;
}

//_____________________________________________________________________________
void RecoClustering::Clear() {
    //
    // Clear
    //

    fNumPoints = 0;
    fSignalFraction = 0.;
    fSigFracOverThresh = 0.;
    fContamination = 1.;
    fContaminationInCluster = 1.;
    fAbsDevMainTheta = 0.;
    fAbsDevMainPhi = 0.;
}
