// $Id: RecoProfile.cc 2759 2006-09-07 08:10:49Z moreggia $
// Author: Sylvain Moreggia   2005/11/16

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: RecoProfile                                                           *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

//_____________________________________________________________________________
//
// RecoProfile
//
// <extensive class description>
//
//   Config file parameters
//   ======================
//
//   <parameter name>: <parameter description>
//   -Valid options: <available options>
//

#include "RecoProfile.hh"

ClassImp(RecoProfile)

//_____________________________________________________________________________
RecoProfile::RecoProfile() {
    //
    // Constructor
    //

}

//_____________________________________________________________________________
RecoProfile::~RecoProfile() {
    //
    // Destructor
    //
}

//_____________________________________________________________________________
RecoProfile::RecoProfile( const RecoProfile& other) {
    //
    // Copy constructor
    //
    other.Copy( *this );
}

//_____________________________________________________________________________
void RecoProfile::Copy( TObject& other ) const {
    //
    // Copy to anew object
    //
    TObject::Copy( other );

    ((RecoProfile&)other).fQuality         = fQuality;
    ((RecoProfile&)other).fXmax            = fXmax;
    ((RecoProfile&)other).fTrueXmax        = fTrueXmax;
    ((RecoProfile&)other).fZshift          = fZshift;
    ((RecoProfile&)other).fThetashift      = fThetashift;
    ((RecoProfile&)other).fRecoTOAImpactX  = fRecoTOAImpactX;
    ((RecoProfile&)other).fRecoTOAImpactY  = fRecoTOAImpactY;
    ((RecoProfile&)other).fRecoTOAImpactZ  = fRecoTOAImpactZ;
    ((RecoProfile&)other).fRecoProfIntegral  = fRecoProfIntegral;
    ((RecoProfile&)other).fSimuProfIntegral  = fSimuProfIntegral;
}

//_____________________________________________________________________________
void RecoProfile::Clear() {
    fQuality     = -1;
    fXmax        = -1;
    fTrueXmax    = -1;
    fZshift      = -1000;
    fThetashift  = -1000;
    fRecoTOAImpactX  = -1000;
    fRecoTOAImpactY  = -1000;
    fRecoTOAImpactZ  = -1000;
    fRecoProfIntegral  = -1;
    fSimuProfIntegral  = -1;
}
