#include "SSurface.h"

#include <G4GeometryTolerance.hh>
#include <globals.hh>

using namespace G4FresnelLens;

double SSurface::kTolerance=1.e-9;
double SSurface::kHalfTolerance=5.e-10;

//______________________________________________________________________________
SSurface::SSurface(double zpos, double rhomax):
fR1(0.), fR(rhomax),
fZpos(zpos),
fZmin(0.), fZmax(0.) {
    kTolerance=G4GeometryTolerance::GetInstance()->GetSurfaceTolerance();
    kHalfTolerance=kTolerance*.5;
}

//__________________________________________________________________________________
#ifdef USE_ROOT
#include <TGraph.h>
#include <TCanvas.h>
#include <TString.h>
#include <TFile.h>
void SSurface::draw(const char* file, const char* canvasfile, double shift, const char* prefix, const char* option){
    TString file1=file;
    TFile* f = new TFile(file1, option);
    TGraph surf;

    double step=0.01, rho, z;
    int i(0);
    while( Point(i, step, rho, z) ){
        surf.SetPoint(surf.GetN(), rho, z+shift);
        i++;
    }
    surf.Write( TString(prefix)+"surf" );
    f->Close();

    if (canvasfile) {
        TCanvas c("surface", "surface");
        surf.Draw("AL");
        c.Print(canvasfile);
    }
}
#endif