#ifndef DetectorFactory_h
#define DetectorFactory_h 1
#include "EsafConfigurable.hh"
#include "EsafMsgSource.hh"

class G4VUserDetectorConstruction;
class DetectorFactory : public EsafConfigurable, public EsafMsgSource{
public:
    DetectorFactory();
    virtual ~DetectorFactory();

    static DetectorFactory*  Instance()   { if (!fMe) return new DetectorFactory(); else return fMe; }

    G4VUserDetectorConstruction* GetDetector();

private:
    static      DetectorFactory *fMe;
    G4VUserDetectorConstruction* fDetector;

    EsafConfigClass(G4,G4Detector)
};

#endif
