#ifndef G4EusoGeometryShape_h
#define G4EusoGeometryShape_h 1

#include <globals.hh>
#include <G4VUserDetectorConstruction.hh>
#include <G4ThreeVector.hh>
#include <G4RotationMatrix.hh>

#include "EsafMsgSource.hh"
#include "EsafConfigurable.hh"
#include "VirtualTelParm.hh"
#include <stdlib.h>
class MaterialParameters;
class G4Material;
class G4VSolid;
class G4OpticalSurface;
class G4EusoGeometryShape : public G4VUserDetectorConstruction, public VirtualTelParm, public EsafMsgSource, public EsafConfigurable
{
public:
    G4EusoGeometryShape();
   ~G4EusoGeometryShape();

public:
    G4VPhysicalVolume* Construct();
    int read_telparm(const char* , const char*);
    int lreadmat();
    Int_t Lcsp_maketable(Double_t x[], Double_t y[], Double_t z[], size_t size);
    Double_t Lcspline(Double_t t, Double_t x[], Double_t y[], Double_t z[], size_t size);
    Double_t LGet_n_Acryl(Double_t);
    Double_t LGet_k_Acryl(Double_t);
    Double_t LGet_n_Cytop(Double_t);
    Double_t LGet_k_Cytop(Double_t);
private:
    void SetMaterial(int i, MaterialParameters* mp,char* material);
    char* lens_dir;
    G4Material* CYTOP;
    G4Material* PMMA;
    G4OpticalSurface* fOpticalSurfaceC;
    G4OpticalSurface* fOpticalSurfaceP;
    G4double expHall_x;
    G4double expHall_y;
    G4double expHall_z;
    double fGeomTolerance;
    bool fit;

    EsafConfigClass(G4,G4EusoGeometryShape)
};

#endif /*G4EusoGeometryShape_h*/
