// G4TransportManager
// This is the kernel of the optics simulation, it trasnports photons
// between the detector elements.
#ifndef G4TransportManager_h
#define G4TransportManager_h

#include "EsafConfigurable.hh"
#include "EsafMsgSource.hh"
#include "VirtualDetectorTransportManager.hh"

class G4RunManager;
class G4VisManager;
//class G4UserTrackingAction;
class OptUserStackingAction;
class OptPrimaryGeneratorAction;
class PhotonsOnPupil;
class G4TransportManager: public VirtualDetectorTransportManager, public EsafConfigurable, public EsafMsgSource{
public:
    G4TransportManager();
    virtual ~G4TransportManager();

    void Go( PhotonsOnPupil* );
    Photon* Transport(Photon *) const;
    void Reset();
    void UIterminal();
private:
    OptPrimaryGeneratorAction* gen_action;
    OptUserStackingAction*         stack_action;
    G4VisManager* visManager;
    G4RunManager* runManager;


    EsafConfigClass(G4,G4TransportManager)
};


#endif /* G4TransportManager_h */
