// ESAF : Euso Simulation and Analysis Framework
// $Id: CellTrackingTrgEngine.hh 1220 2004-11-26 17:32:38Z thea $
// P. Asiz created Nov. 6, 2004
// tracking built in macrocell logic
//

#ifndef __CELLTRACKINGTRGENGINE_HH_
#define __CELLTRACKINGTRGENGINE_HH_

#include "euso.hh"
#include "TriggerEngine.hh"

class CellTrackingTrgEngine : public TriggerEngine {
public:
    // ctor
    CellTrackingTrgEngine();

    // dtor
    virtual ~CellTrackingTrgEngine();
    
    // simulate trigger
    virtual void Simulate( MacroCellData* );

    EsafConfigClass(Electronics,CellTrackingTrgEngine);

private:

    vector<Bool_t>  VecBitAnd(vector<Bool_t> A, vector<Bool_t> B);
    Bool_t  VecEmpty (vector<Bool_t> A);
    vector<Bool_t> VecShift(vector<Bool_t> vec, int shift);

    ClassDef(CellTrackingTrgEngine,0)

};

#endif  /* __CELLTRACKINGTRGENGINE_HH_ */

