// $Id: EChipTriggParsFiller.hh 2381 2005-11-17 09:11:46Z pesce $
// Author: R. Pesce   2005/10/21

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: EChipTriggParsFiller                                                 *
 *  Package: Electronics                                                     *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __ECHIPTRIGGPARSFILLER_HH__
#define __ECHIPTRIGGPARSFILLER_HH__

#include "euso.hh"
#include "ERunParsFiller.hh"
#include "Etypes.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// EChipTriggParsFiller                                                       //
//                                                                            //  
// This is the interface class that fills the chip tracking trigger           //
// parameters in the rootfile.                                                //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class EChipTriggParsFiller : public ERunParsFiller {
public:
    EChipTriggParsFiller();
    virtual ~EChipTriggParsFiller();

    virtual void Fill( ERunParameters * );

    // setters
    inline void SetName(const char* name) { fName=name; }
    inline void SetId(ETriggerTypeIdentifier id) { fId=id; }
    inline void SetRelativeThreshold(Bool_t b) { fRelativeThreshold=b; }
    inline void SetThreshold(Int_t t) { fThreshold=t; }
    inline void SetMinTrackLength(Int_t l) { fMinTrackLength=l; }
    inline void SetMaxTrackLength(Int_t l) { fMaxTrackLength=l; }
    inline void SetMinTriggerTrackLength(Int_t l) { fMinTriggerTrackLength=l; }
    inline void SetMinTriggerTwoLength(Int_t l) { fMinTriggerTwoLength=l; }
    inline void SetMaxTwoLength(Int_t l) { fMaxTwoLength=l; }
    inline void SetAcceptHole(Bool_t b) { fAcceptHole=b; }
    inline void SetOnlyWithSignal(Bool_t b) { fOnlyWithSignal=b; }

private:
    const char* fName;
    ETriggerTypeIdentifier fId;

    Bool_t fRelativeThreshold;
    Int_t fThreshold;
    Int_t fMinTrackLength;
    Int_t fMaxTrackLength;
    Int_t fMinTriggerTrackLength;
    Int_t fMinTriggerTwoLength;
    Int_t fMaxTwoLength;
    Bool_t fAcceptHole;
    Bool_t fOnlyWithSignal;
    
    void Clear();

    ClassDef(EChipTriggParsFiller,0)
};

#endif  /* __ECHIPTRIGGPARSDATAADDER_HH__ */

