// ESAF : Euso Simulation and Analysis Framework
// $Id: EDetectorPhotonAdder.hh 2261 2005-10-24 10:40:26Z pesce $
// Author: A.Thea created Oct, 24 2003

#ifndef __EDETECTORPHOTONADDER_HH_
#define __EDETECTORPHOTONADDER_HH_

#include <TArrayI.h>
#include "euso.hh"
#include "EFiller.hh"
#include "EsafMsgSource.hh"

class Photon;
class PmtSignal;

class EDetectorPhotonAdder : public EFiller, public EsafMsgSource {
public:
    // ctor
    EDetectorPhotonAdder(Photon*, PmtSignal*, Bool_t newph = false);
    
    // alternative ctor to fill photon history
    EDetectorPhotonAdder(TArrayI);

    // dtor
    virtual ~EDetectorPhotonAdder();

    virtual void Fill( EFillable *);

private:
    Photon *fPhoton;
    PmtSignal *fSignal;
    Bool_t fNewPh;

    TArrayI fPhotonHistory;

    ClassDef(EDetectorPhotonAdder,0)
};

#endif  /* __EDETECTORPHOTONADDER_HH_ */

