// $Id: ELblTrackTriggerDataAdder.hh 2168 2005-10-10 16:28:03Z ejudd $
// Author: E.Judd   2005/07/22

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: ELblTrackTriggerDataAdder                                            *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __ELBLTRACKTRIGGERDATAADDER_HH__
#define __ELBLTRACKTRIGGERDATAADDER_HH__

#include "euso.hh"
#include "EFiller.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// ELblTrackTriggerDataAdder                                                  //
//                                                                            //  
// This function fills the ELblTrackTrigger branch of the ROOT output         //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class LblTrackSegment;

class ELblTrackTriggerDataAdder : public EFiller {
public:
    ELblTrackTriggerDataAdder( LblTrackSegment*, Int_t, Int_t );
    // ctor
    
    virtual ~ELblTrackTriggerDataAdder();
    // dtor
    
    virtual void Fill( EFillable *);
    // filler

private:
    Int_t fCellId;               // macrocell id
    Int_t fChipId;               // chip unique id
    LblTrackSegment *fLblTrack;  // track segment infos

    ClassDef(ELblTrackTriggerDataAdder,0)
};

#endif  /* __ELBLTRACKTRIGGERDATAADDER_HH__ */

