// ESAF : Euso Simulation and Analysis Framework
// $Id: FullAnalogFrontEnd.hh 1112 2004-09-28 12:10:53Z thea $
// M. Pallavicini created Jul,  2 2002
// Full analog front end electronics simulation
// one ADC value for each channel and for each GTU

#ifndef __FULLANALOGFRONTEND_HH_
#define __FULLANALOGFRONTEND_HH_

#include "euso.hh"
#include "AnalogFrontEnd.hh"
#include "Config.hh"

class FullAnalogFrontEnd : public AnalogFrontEnd {
public:
    FullAnalogFrontEnd( FrontEndChip*, Int_t size );
    virtual ~FullAnalogFrontEnd();

    EsafConfigClass( Electronics, FullAnalogFrontEnd )

    // reset (clear Int_ternal variables and status)
    virtual void Reset( Int_t );

    // add a photon for one specific channel and GTU
    // last bool is true if DFEE has triggered on this channel and GTU 
    virtual void Add( const PmtSignal&, Int_t, int );

    // simulate fGtu response
    virtual void Simulate( ChipGtuData* );

private:
    Int_t fSize;         // number of channels
    Int_t fGtu;          // gtu id 
    Double_t *fCharge;   // measured charge per channel
    Double_t fDynode;    // total dynode charge

    ClassDef(FullAnalogFrontEnd,0)
};

#endif  /* __FULLANALOGFRONTEND_HH_ */

