// $Id$
// Author: fenu   2007/12/05

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: LTTTrigger                                                           *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __LTTTRIGGER_HH__
#define __LTTTRIGGER_HH__

#include "euso.hh"
#include "TriggerEngine.hh"
#include "LTTTriggerSegment.hh"
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// LTTTrigger                                                                 //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class LTTTrigger:public TriggerEngine
{
public:
  LTTTrigger ();
  virtual ~ LTTTrigger ();
  // simulate trigger
  virtual void Simulate (MacroCellData *);

protected:
// Upper level threshold
    Int_t fRedThreshold;
// Lower level threshold
  Int_t fYellowThreshold;
// Integrate  threshold
  Int_t fIntegrateSum;
  string fDataDirectory;
  string fDirectionFileName;
  Int_t Flag_debug_table;
  Int_t flag_EC;
  string fDebugFlag;
  Int_t fChainPTT_LTT;
  Int_t fNum_Dir,fNum_Steps;
  Float_t fGtuLight, fPixel_size;
  Float_t   fGTU,fBack;
  //Informations about all the events
    vector < int >PDM_Map;
    vector < int >pos_PDM_map;
    vector < Float_t > kx_ky;
    vector < Float_t > angle;
     vector < LTTTriggerSegment > fTracks;

  void Calculate_Directions ();
// clear memory
  virtual void Clear ();

//Perform the integration
  void integrate (vector < int >, vector < int >, MacroCellData *,Int_t,Int_t);

  void CorrectTransformation (Int_t, Int_t, Int_t, Int_t, Int_t *, Int_t *,
			      Int_t *,Int_t,Int_t);

  void IntegrateCounts (Int_t *, Int_t, Int_t, Int_t, Int_t, MacroCellData *,
			vector < int >,
			vector < int >, Int_t, Int_t, Int_t, Int_t, Int_t,Int_t,Int_t);

  void Debug_Table1 (Float_t, Float_t, Float_t, Int_t, Int_t, Int_t, Int_t);

  void Debug_Table2 (Float_t, Float_t, Float_t, Int_t, Int_t, Int_t, Int_t,
		     Int_t);

  virtual void FillInfoVector(Int_t,Int_t,Int_t,Int_t,Int_t,Int_t,Int_t);

    void FillChipData(Int_t,Int_t,Int_t,Int_t,Int_t,Int_t,Int_t,MacroCellData*);


    friend class CCB_LTTTrigger;
    EsafConfigClass (Electronics, LTTTrigger);
  ClassDef (LTTTrigger, 0)
};

#endif /* __LTTTRIGGER_HH__ */
