// ESAF : Euso Simulation and Analysis Framework
// $Id: LblTrackSegment.hh 2168 2005-10-10 16:28:03Z ejudd $
// E. Judd created July, 26 2005
// Track found by LblChipTrackingTrgEngine
// 
#ifndef __LBLTRACKSEGMENT_HH_
#define __LBLTRACKSEGMENT_HH_

#include <iostream>
#include "euso.hh"

class LblTrackSegment {
public:
    // ctor
    LblTrackSegment();

    // dtor
    virtual ~LblTrackSegment();
    
    inline Int_t GetGtuStart() const { return fGtuStart; }
    inline Int_t GetGtuEnd() const { return fGtuEnd; }
    inline Int_t GetRowStart() const { return fRowStart; }
    inline Int_t GetRowEnd() const { return fRowEnd; }
    inline Int_t GetColStart() const { return fColStart; }
    inline Int_t GetColEnd() const { return fColEnd; }
    inline Int_t GetNumSegs() const { return fNumSegs; }
    inline Int_t GetSum() const { return fSum; }
    inline Int_t GetTriggerID() const { return fTriggerID; }
    
    inline void SetGtuStart(Int_t v) { fGtuStart = v; }
    inline void SetGtuEnd(Int_t v) { fGtuEnd = v; }
    inline void SetRowStart(Int_t v) { fRowStart = v; }
    inline void SetRowEnd(Int_t v) { fRowEnd = v; }
    inline void SetColStart(Int_t v) { fColStart = v; }
    inline void SetColEnd(Int_t v) { fColEnd = v; }
    inline void SetNumSegs(Int_t v) { fNumSegs = v; }
    inline void SetSum(Int_t v) { fSum = v; }
    inline void SetTriggerID(Int_t v) { fTriggerID = v; }


private: 
    ClassDef(LblTrackSegment,0)

    // first gtu
    Int_t fGtuStart;

    // last gtu
    Int_t fGtuEnd;

    // first channel
    Int_t fRowStart;
    Int_t fColStart;

    // last channel
    Int_t fRowEnd;
    Int_t fColEnd;

    // number of sections
    Int_t fNumSegs;

    // Total sum
    Int_t fSum;

    // -1 if track is not part of a trigger, else trigger number
    Int_t fTriggerID;
};
    
#endif  /* __LBLTRACKSEGMENT_HH_ */

