// $Id$
// Author: fenu   2007/12/05

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: PTTTrigger                                                           *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __PTTTRIGGER_HH__
#define __PTTTRIGGER_HH__

#include "euso.hh"
#include "TriggerEngine.hh"
#include "PTTTriggerSegment.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// CatalanaoTrigger                                                           //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class PTTTrigger:public TriggerEngine
{
public:
  PTTTrigger ();
    virtual ~ PTTTrigger ();
  void Clear ();
  // simulate trigger
  virtual void Simulate (MacroCellData *);

protected:
    Int_t Flag_debug_table;
  Int_t fPixelThr;
  Int_t fPersistency;
  Int_t fIntegration;
  Int_t chip_ID_up, row_up, col_up, GTU_up, up_counts;
  Int_t side_EC;
  Int_t side_PMT;

   vector < PTTTriggerSegment > fTracks;

private:
  void FillEEvent (Int_t);
  void Debug_Table1 (Float_t, Float_t, Float_t, Int_t, Int_t, Int_t, Int_t);
  void Debug_Table2 (Float_t, Float_t, Float_t, Int_t, Int_t, Int_t, Int_t,
		     Int_t);
  void Transform (Int_t *, Int_t *);

    EsafConfigClass (Electronics, PTTTrigger);
  ClassDef (PTTTrigger, 1)};

#endif /* __PTTTRIGGER_HH__ */
