// $Id: PhPToRootFileDetector.hh 2604 2006-03-20 21:51:35Z thea $
// Author: Alessandro Thea   2005/02/13

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: PhPToRootFileDetector                                                *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __PHPTOROOTFILEDETECTOR_HH__
#define __PHPTOROOTFILEDETECTOR_HH__

#include "euso.hh"
#include "Detector.hh"

class TFile;
class TTree;
class ETruth;
class EGeometry;
class TClonesArray;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// PhPToRootFileDetector                                                      //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class PhPToRootFileDetector : public Detector, public EsafConfigurable, public EsafMsgSource {
public:
    PhPToRootFileDetector();
    virtual ~PhPToRootFileDetector();

    virtual void Reset();

    virtual Telemetry* Get( PhotonsOnPupil* );
    // do the complete simulation of one event

    virtual Bool_t ClearMemory();
protected:
    virtual void Initialize();
    virtual void Finalize();

    string fFileName;
    TFile *fFile;
    TTree *fTree;
    ETruth *fRootTruth;
    EGeometry *fRootGeometry;
    TClonesArray *fPhotons;
    Int_t fNumPhotons;

    static const UInt_t fgStartBufferSize;
        
    EsafConfigClass(Electronics,PhPToRootFileDetector)
    ClassDef(PhPToRootFileDetector,0)
};

#endif  /* __PHPTOROOTFILEDETECTOR_HH__ */

