// ESAF : Euso Simulation and Analysis Framework
// $Id: R8900M36Photomultiplier.hh 1283 2004-12-09 23:20:42Z thea $
// A.Thea created Mar, 26 2003
//
// S.Ogawa & M. Bertaina 2004-11-26

#ifndef __R8900M36PHOTOMULTIPLIER_HH_
#define __R8900M36PHOTOMULTIPLIER_HH_

#include "euso.hh"
#include "Photomultiplier.hh"
#include "Interpolate.hh"

class R8900M36Photomultiplier : public Photomultiplier {
public:
    R8900M36Photomultiplier( Int_t, PmtGeometry* );
    virtual ~R8900M36Photomultiplier();

    EsafConfigClass(Electronics,R8900M36Photomultiplier)
 
    virtual Bool_t Add(Photon& ph);

private:

  enum EStatus { kUndefined,
                 kPmtAdd,           
                 kR8900Add};

  static EStatus fgStatus;

  //---- Satoi & Mario changes -----
  static vector<Double_t>   fgColEff;              // Collection efficiency
  static Interpolate*       fgQuantumEff;          // Quantum efficiency 
  static Interpolate*       fgAngularDependence;   // Angular dependence
  static vector<Double_t>* fgCrossTalkTable;      // Cross Talk Full table

  // --- end Satoi & Mario changes -----
    ClassDef(R8900M36Photomultiplier,0)
};

#endif  /* __R8900M36PHOTOMULTIPLIER_HH_ */

