// $Id$
// Author: fenu2   2009/10/26

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: ECCB_LTTTriggerDataAdder                                                           *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

//_____________________________________________________________________________
//
// ECCB_LTTTriggerDataAdder
//
// <extensive class description>
//
//   Config file parameters
//   ======================
//
//   <parameter name>: <parameter description>
//   -Valid options: <available options>
//

#include "ECCB_LTTTriggerDataAdder.hh"
#include "ECCB_LTTTrigger.hh"
#include "TBranchElement.h"
#include "TObject.h"
#include "TBuffer.h"
#include "CCB_LTTTriggerSegment.hh"
#include "ECCB_LTTTriggerSegment.hh"

ClassImp(ECCB_LTTTriggerDataAdder)

//_____________________________________________________________________________
ECCB_LTTTriggerDataAdder::ECCB_LTTTriggerDataAdder(CCB_LTTTriggerSegment* seg,Int_t evt_id,Int_t cell_id) : EFiller("ECCB_LTTTrigger") {
    //
    // Constructor
    //
  fCCB_LTTTrack=seg;
  fCellId=cell_id;              
  fEvtId=evt_id;
}

//_____________________________________________________________________________
ECCB_LTTTriggerDataAdder::~ECCB_LTTTriggerDataAdder() {
    //
    // Destructor
    //
}

void ECCB_LTTTriggerDataAdder::Fill( EFillable * f){
  ECCB_LTTTrigger *trg = (ECCB_LTTTrigger*)f;
  if ( !fCCB_LTTTrack ) return;

  new ( (*(trg->fCCB_LTTFlag))[trg->fNumTrigg++] ) ECCB_LTTTriggerSegment();

  //fill track properties
  ECCB_LTTTriggerSegment& seg = *(ECCB_LTTTriggerSegment*)(*(trg->fCCB_LTTFlag))[trg->fNumTrigg-1]; 
 
  seg.SetMaxCount(fCCB_LTTTrack->GetMaxCount());
  seg.SetNumEvt(fCCB_LTTTrack->GetNumEvt());
  seg.SetMaxGtu(fCCB_LTTTrack->GetMaxGtu());
  seg.SetMaxRow(fCCB_LTTTrack->GetMaxRow());
  seg.SetMaxCol(fCCB_LTTTrack->GetMaxCol());
  seg.SetMaxChipID(fCCB_LTTTrack->GetMaxChipID());
  seg.SetMaxDir(fCCB_LTTTrack->GetMaxDir());

}
