// $Id$
// Author: fenu2   2009/10/26

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: ELTTTriggerDataAdder                                                           *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

//_____________________________________________________________________________
//
// ELTTTriggerDataAdder
//
// <extensive class description>
//
//   Config file parameters
//   ======================
//
//   <parameter name>: <parameter description>
//   -Valid options: <available options>
//

#include "ELTTTriggerDataAdder.hh"
#include "ELTTTrigger.hh"
#include "TBranchElement.h"
#include "TObject.h"
#include "TBuffer.h"
#include "LTTTriggerSegment.hh"
#include "ELTTTriggerSegment.hh"

ClassImp(ELTTTriggerDataAdder)

//_____________________________________________________________________________
ELTTTriggerDataAdder::ELTTTriggerDataAdder(LTTTriggerSegment* seg,Int_t evt_id,Int_t cell_id) : EFiller("ELTTTrigger") {
    //
    // Constructor
    //
  fLTTTrack=seg;
  fCellId=cell_id;              
  fEvtId=evt_id;
}

//_____________________________________________________________________________
ELTTTriggerDataAdder::~ELTTTriggerDataAdder() {
    //
    // Destructor
    //
}

void ELTTTriggerDataAdder::Fill( EFillable * f){
  ELTTTrigger *trg = (ELTTTrigger*)f;
  if ( !fLTTTrack ) return;

  new ( (*(trg->fLTTFlag))[trg->fNumTrigg++] ) ELTTTriggerSegment();

  //fill track properties
  ELTTTriggerSegment& seg = *(ELTTTriggerSegment*)(*(trg->fLTTFlag))[trg->fNumTrigg-1]; 
 
  seg.SetMaxCount(fLTTTrack->GetMaxCount());
  seg.SetNumEvt(fLTTTrack->GetNumEvt());
  seg.SetMaxGtu(fLTTTrack->GetMaxGtu());
  seg.SetMaxRow(fLTTTrack->GetMaxRow());
  seg.SetMaxCol(fLTTTrack->GetMaxCol());
  seg.SetMaxChipID(fLTTTrack->GetMaxChipID());
  seg.SetMaxDir(fLTTTrack->GetMaxDir());

}
