// $Id$
// Author: fenu2   2009/10/26

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: EPTTTriggerDataAdder                                                           *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

//_____________________________________________________________________________
//
// EPTTTriggerDataAdder
//
// <extensive class description>
//
//   Config file parameters
//   ======================
//
//   <parameter name>: <parameter description>
//   -Valid options: <available options>
//

#include "EPTTTriggerDataAdder.hh"
#include "EPTTTrigger.hh"
#include "TBranchElement.h"
#include "TObject.h"
#include "TBuffer.h"
#include "PTTTriggerSegment.hh"
#include "EPTTTriggerSegment.hh"

ClassImp (EPTTTriggerDataAdder)
//_____________________________________________________________________________
EPTTTriggerDataAdder::EPTTTriggerDataAdder (PTTTriggerSegment * seg, Int_t evt_id, Int_t cell_id):
EFiller
  ("EPTTTrigger")
{
  //
  // Constructor
  //
  fPTTTrack = seg;
  fCellId = cell_id;
  fEvtId = evt_id;
}

//_____________________________________________________________________________
EPTTTriggerDataAdder::~EPTTTriggerDataAdder ()
{
  //
  // Destructor
  //
}

void
EPTTTriggerDataAdder::Fill (EFillable * f)
{
  EPTTTrigger *trg = (EPTTTrigger *) f;
  if (!fPTTTrack)
    return;

  new ((*(trg->fPTTFlag))[trg->fNumTrigg++]) EPTTTriggerSegment ();

  //fill track properties
  EPTTTriggerSegment & seg =
    *(EPTTTriggerSegment *) (*(trg->fPTTFlag))[trg->fNumTrigg - 1];

  seg.SetMaxCount (fPTTTrack->GetMaxCount ());
  seg.SetNumEvt (fPTTTrack->GetNumEvt ());
  seg.SetMaxGtu (fPTTTrack->GetMaxGtu ());
  seg.SetMaxRow (fPTTTrack->GetMaxRow ());
  seg.SetMaxCol (fPTTTrack->GetMaxCol ());
  seg.SetMaxChipID (fPTTTrack->GetMaxChipID ());

}
