// $Id: ESimpleDetectorPhotoElecAdder.cc 2766 2006-11-15 15:49:03Z moreggia $
// Author: Sylvain Moreggia   2006/03/21

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: ESimpleDetectorPhotoElecAdder                                        *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

//_____________________________________________________________________________
//
// ESimpleDetectorPhotoElecAdder
//
// <extensive class description>
//
//   Config file parameters
//   ======================
//
//   <parameter name>: <parameter description>
//   -Valid options: <available options>
//

#include "ESimpleDetectorPhotoElecAdder.hh"
#include "PhotoElectron.hh"
#include "EPhotoElectron.hh"
#include "EEvent.hh"
#include "ESimpleDetector.hh"
#include "Etypes.hh"

ClassImp(ESimpleDetectorPhotoElecAdder)

//_____________________________________________________________________________
ESimpleDetectorPhotoElecAdder::ESimpleDetectorPhotoElecAdder(PhotoElectron* pe, Bool_t newpe) 
                              : EFiller("ESimpleDetector"), EsafMsgSource() {
    //
    // Constructor
    //
    
    fPe    = pe;
    fNewPe = newpe;
    
}

//_____________________________________________________________________________
ESimpleDetectorPhotoElecAdder::~ESimpleDetectorPhotoElecAdder() {
    //
    // Destructor
    //
}

//______________________________________________________________________________
void ESimpleDetectorPhotoElecAdder::Fill( EFillable* f ) {
    //
    // filler
    //

    ESimpleDetector *det;
    if ( !(det = dynamic_cast<ESimpleDetector*>(f)) ) {
        MsgForm(EsafMsg::Warning,"Fill(): f is not an ESimpleDetector* ");
        return; 
    }


    if ( !fPe ) return;



    // add a new pe-
    if(fNewPe) new ( (*(det->fPhotoElectrons))[det->fNumPhotoElectrons++] ) EPhotoElectron();
    EPhotoElectron& pe = *(EPhotoElectron*)(*(det->fPhotoElectrons))[det->fNumPhotoElectrons-1];


    // pe- parameters
    if ( fNewPe ) {
        pe.fType               = fPe->Type();
        pe.fPixelID            = fPe->PixelID();
        pe.fTime               = fPe->Time();
        pe.fSNR                = fPe->SNR();
        pe.fTriggered          = fPe->IsTriggered();
        pe.fWl                 = fPe->Wl();
        pe.fShowerAge          = fPe->ShowerAge();
        
	pe.fAtmoPosX           = fPe->AtmoPos().X();
        pe.fAtmoPosY           = fPe->AtmoPos().Y();
        pe.fAtmoPosZ           = fPe->AtmoPos().Z();
       
        pe.fAtmoHistory        = fPe->AtmoHistory();
        pe.fAtmoNbinter        = fPe->AtmoNbinter();
        pe.fDist2ShiftToShowPt = fPe->Dist2ShiftToShowPt();
    }
}


