// $Id: ConicBaffle.hh 1669 2005-04-08 17:40:25Z thea $
// Author: Alessandro Thea   2005/04/08

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: ConicBaffle                                                          *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __CONICBAFFLE_HH__
#define __CONICBAFFLE_HH__

#include "euso.hh"
#include "Baffle.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// ConicBaffle                                                                //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class ConicBaffle : public Baffle {
public:
    ConicBaffle();
    virtual ~ConicBaffle();

    virtual Photon* Transport( Photon * ) const;
protected:
    Double_t NextInteraction( Photon* ) const;

    Double_t fAlpha;    // cone's angle
    Double_t fCotAlpha; // cotangent of the cone's angle
    Double_t fVPosZ;    // z coordinate of the cone's vertex

private:

    EsafConfigClass(Optics,ConicBaffle)

    ClassDef(ConicBaffle,0)
};

#endif  /* __CONICBAFFLE_HH__ */

