// $Id: FastFocalPlane.hh 1523 2005-02-17 17:24:49Z thea $
// Author: A.Thea   Jul, 19 2004

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: FastFocalPlane                                                       *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

#ifndef FASTFOCALPLANE_HH
#define FASTFOCALPLANE_HH

#include "DetectorPhotonTransporter.hh"
#include "FocalPlane.hh"
#include "MacroCellGeometry.hh"
#include "OpticsFactory.hh"
#include "EusoElectronics.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// FastFocalPlane                                                             //
//                                                                            //
// Fast implementation of the focal plane.                                    //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

class FastFocalPlane: public FocalPlane {
public:
    virtual ~FastFocalPlane();
    virtual Photon *Transport(Photon *) const;
    Photon* HitMC(Photon *p, MacroCellGeometry *g) const;
protected:
    FastFocalPlane();

	EsafConfigClass(Optics,FastFocalPlane)

    ClassDef(FastFocalPlane,0)
};

#endif /* FASTFOCALPLANE_HH */
