// FocalPlane
// $Id: FocalPlane.hh 2804 2008-10-09 12:10:06Z biktem $
//
// Abstarct base class providing the interface of a generic focal plane
//


#ifndef __FOCALPLANE_HH__
#define __FOCALPLANE_HH__

#include "DetectorPhotonTransporter.hh"

class EusoElectronics;

class FocalPlane: public DetectorPhotonTransporter {
public:
    FocalPlane() {}
    virtual Photon *Transport(Photon *) const = 0;

    virtual void SetElectronics( EusoElectronics* e ) { fElectronics = e; }
    virtual EusoElectronics* GetElectronics() const { return fElectronics; }

protected:
    EusoElectronics* fElectronics;

	EsafConfigClass(Optics,FocalPlane)

    ClassDef(FocalPlane,0)
};

class TestFocalPlane: public FocalPlane {
public:
    TestFocalPlane();
    virtual Photon *Transport(Photon *) const;

    EsafConfigClass(Optics,TestFocalPlane)

    ClassDef(TestFocalPlane,0)
};

#endif /* __FOCALPLANE_HH__ */
