// $Id: IdealOpticalAdaptor.hh 1786 2005-04-26 15:38:55Z thea $
// Author: A.Thea    22/10/2002

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: IdealOpticalAdaptor                                                  *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

#ifndef __IDEALOPTICALADAPTOR_HH__
#define __IDEALOPTICALADAPTOR_HH__

#include "OpticalAdaptor.hh"
#include "PmtGeometry.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// IdealOpticalAdaptor                                                        //
//                                                                            //
// Ideal optical adaptor                                                      //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

class IdealOpticalAdaptor: public OpticalAdaptor {
public:
    IdealOpticalAdaptor();
    virtual Photon *Transport( Photon * ) const;

private:
    Double_t fSmallSide;          // bottom face side of optical adaptor
    Double_t fScale;    	      // scale reduction factor
    
    EsafConfigClass(Optics,IdealOpticalAdaptor)

    ClassDef(IdealOpticalAdaptor,0)
};

#endif /* __IDEALOPTICALADAPTOR_HH__ */
