// $Id: KIdealFocalSurface.hh 1734 2005-04-15 18:54:42Z thea $
// Author: J.Watts  2003/09/21

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: KIdealFocalSurface                                                   *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

#ifndef __KIDEALFOCALSURFACE_HH__
#define __KIDEALFOCALSURFACE_HH__

#include "euso.hh"
#include "IdealFocalSurface.hh"
#include "EsafMsgSource.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// KIdealFocalSurface                                                         //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class KIdealFocalSurface : public IdealFocalSurface, public EsafMsgSource {
public:
    KIdealFocalSurface();
    virtual ~KIdealFocalSurface();

    virtual Bool_t HitPosition(Photon *p);
    
    virtual Double_t Profile( Double_t r);
    
    EsafConfigClass(Optics,KIdealFocalSurface)
private:
    Double_t Zfs(Double_t r);
    Double_t fRho, fK, fA, fB, fC, fD;  // FS parameters
    Double_t fPrec;                     // precision required to claim 
                                        // that the photon has hit the FS

    ClassDef(KIdealFocalSurface,0)
};          

#endif  /* __KIDEALFOCALSURFACE_HH__ */

