// $Id: LOpticalSystem.hh 2849 2010-11-11 11:59:41Z biktem $
// Author: Dmitry V.Naumov   2007/11/13

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: LOpticalSystem                                                       *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

#ifndef __LOPTICALSYSTEM_HH__
#define __LOPTICALSYSTEM_HH__

#include "euso.hh"
#include "OpticalSystem.hh"
#include "Ltracemain_optF1v4.hh"
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// LOpticalSystem                                                             //
//                                                                            //
// <brief class description>                                                  //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////


class LOpticalSystem : public OpticalSystem {
public:
    LOpticalSystem();
    virtual ~LOpticalSystem();
    virtual Photon* Transport(Photon *p) const;
    virtual Bool_t HitSide(Photon *p) const;

    EsafConfigClass(Optics,LOpticalSystem)

private:
    // checks if a not 0 flag photon is going out
    Bool_t IsGoingOut(Photon *p) const;

    FILE*                        fLogFile;
    ClassDef(LOpticalSystem,0)

};

#endif  /* __LOPTICALSYSTEM_HH__ */

