/* -------------------------------------------------------------------------
 *   tracemain_optF1v4.h
 *
 *   --- header file for tracemain_optF1v4.h
 *
 * Copyright (c) 2000-2007 N.Sakaki, Y.Takizawa, Y.Kawasaki
 * All rights reserved.
 * $Id: Ltracemain_optF1v4.hh 2849 2010-11-11 11:59:41Z biktem $
 * $Id: Ltracemain_optF1v4.hh,v 1.0 2007/11/13 Dmitry V.Naumov adapted for ESAF
 * -------------------------------------------------------------------------
 */
#ifndef _LTRACEMAIN_OPTF1V4_H
#define _LTRACEMAIN_OPTF1V4_H

#include <stdio.h>
#include "Rtypes.h"

#define LFS_TOLERANCE   0.01  /* mm */
#define LFS_DEF_STEP    0.1   /* mm */
#define LFSLOOP_MAX      100



typedef struct _tel_param{
  Double_t Lr_lens, Lr_wall, Lr_fs;
  Double_t LSz0;
  Double_t LRc1,LSz1,LZc1;
  Double_t LRc2,LSz2,LZc2;
  Double_t LRc4,LSz4,LZc4;
  Double_t LRc6,LSz6,LZc6;
  Double_t LRc7,LSz7,LZc7;
  Double_t LZc3,LRc3;
  Double_t LZcD,LRcD;
  Double_t LFS_C, LFS_K, LFSA, LFSB, LFSC, LFSD, LFS_OFFSET; /* for FS */
  Double_t Llambda0; /* nm */
  char Llens_dir[256];
} tel_param;

Int_t Lread_tel_param(char *filename, tel_param *param, FILE *fplog);
Int_t Lprint_param(tel_param *p);
Int_t Ltrace_main(tel_param *param,
               Double_t ph_in[8], Double_t ph_out[8], FILE *fplog);
Double_t LFocalSurface(Double_t r, tel_param *p);

#endif
