// $Id: LIdealFocalSurface.hh 2828 2009-04-01 14:29:16Z biktem $
// Author: Dmitry V.Naumov  2007/11/16

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: MIdealFocalSurface                                                   *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

#ifndef __MIDEALFOCALSURFACE_HH__
#define __MIDEALFOCALSURFACE_HH__

#include "euso.hh"
#include "IdealFocalSurface.hh"
#include "EsafMsgSource.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// MIdealFocalSurface                                                         //
//                                                                            //
// <brief class description>                                                  //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

class MIdealFocalSurface : public IdealFocalSurface, public EsafMsgSource {
public:
    MIdealFocalSurface();
    virtual ~MIdealFocalSurface();

    virtual Bool_t HitPosition(Photon *p);

    virtual Double_t Profile( Double_t r);

    EsafConfigClass(Optics,MIdealFocalSurface)

private:
    Double_t Zfs(Double_t r);
    Double_t fRho, fK, fA, fB, fC, fD;  // FS parameters
    Double_t fPrec;                     // precision required to claim
                                        // that the photon has hit the FS

    ClassDef(MIdealFocalSurface,0)
};

#endif  /* __MIDEALFOCALSURFACE_HH__ */

