// $Id: MOpticalSystem.hh 2784 2007-11-16 10:19:08Z naumov $
// Author: Dmitry V.Naumov   2007/11/13

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: MOpticalSystem                                                       *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

#ifndef __MOPTICALSYSTEM_HH__
#define __MOPTICALSYSTEM_HH__

#include "euso.hh"
#include "OpticalSystem.hh"
#include "Mtracemain_optF1v4.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// MOpticalSystem                                                             //
//                                                                            //
// <brief class description>                                                  //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////


class MOpticalSystem : public OpticalSystem{
public:
    MOpticalSystem();
    virtual ~MOpticalSystem();
    virtual Photon* Transport(Photon *p) const;
    virtual Bool_t HitSide(Photon *p) const;

    EsafConfigClass(Optics,MOpticalSystem)

private:
    // checks if a not 0 flag photon is going out
    Bool_t IsGoingOut(Photon *p) const;

    FILE*                        fLogFile;
    ClassDef(MOpticalSystem,0)
};

#endif  /* __MOPTICALSYSTEM_HH__ */

