/* -------------------------------------------------------------------------
 *   trace_optF1v4.h
 *
 *   --- header file for trace_optF1v4.h
 *
 * Copyright (c) 2000-2007 N.Sakaki, Y.Takizawa, Y.Kawasaki
 * All rights reserved.
 * $Id$
 * -------------------------------------------------------------------------
 */
#ifndef _MTRACE_OPTF1V4_H
#define _MTRACE_OPTF1V4_H

#include <stdio.h>
#include "Mtracemain_optF1v4.hh"
#include "Rtypes.h"

/* the following numbers are related to the data files. */

#define Acryl_N 71
#define Cytop_N 71
#define Bg3_N   22

#define RT_NO_SPINTERSECTION       -2
#define RT_HIT_SIDE_WALL           -3
#define RT_NO_INTERSECTION1        -4
#define RT_NO_INTERSECTION2        -5
#define RT_OUT_OF_SURFACE1         -6
#define RT_OUT_OF_SURFACE2         -7
#define RT_REFLECTION_DISCARDED    -8
#define RT_NO_REFRACTED_LIGHT      -9
#define RT_REFLECTED_IN_REF       -10
#define RT_ABSORBED               -11
#define RT_OUT_OF_IRIS            -12
#define RT_STRAY_LIGHT            -13
#define RT_ESCAPE_FROM_ENTRANCE   -14
#define RT_EXCEED_ITER_MAX        -15
#define RT_OUT_OF_DOES            -16

#define RT_REFRACTED                1
#define RT_REFLECTED                2

#define SURFACE0                    0
#define SURFACE1                -1000
#define SURFACE2                -2000
#define SURFACE3                -3000
#define SURFACE4                -4000
#define SURFACED                -5000
#define SURFACE5                -5000
#define SURFACE6                -6000
#define SURFACE7                -7000
#define SURFACE_FS             -8000

/* speed of light in mm/ns */
//#define C0 299.792458
/* the current optics is designed to be put in air.
Maybe little change for vacuum.  */
#define REFRACTIVE_IDX_MEDIA 1.0003   /* air */

int ReadLensData(Mtel_param *param, FILE *fplog);
double Get_n_Acryl(double lambda);
double Get_n_Cytop(double lambda);
double Get_k_Acryl(double lambda);
double Get_k_Cytop(double lambda);
int refract(double in_ph[3],double nnn[3],double n1,double n2);
int trace_lens(Mtel_param *param, double ph_in[], double ph_out[], FILE *fplog);
int CalSpheVec(double aX, double aY, double aZ, double aCZ, double nnnDIFF[3]);
int ReadDiffractData(char *dirname, FILE *fplog);
double Cal_D(double r);
int diffract(int ID, double in_phdir[3],
         double x3, double y3, double z3, double Zc,
         double n1, double n2, double wl, double wl0, int m);
int CheckRcut(Mtel_param *p, double phot[6], int flag);
#endif
