/* -------------------------------------------------------------------------
 *   tracemain_optF1v4.h
 *
 *   --- header file for tracemain_optF1v4.h
 *
 * Copyright (c) 2000-2007 N.Sakaki, Y.Takizawa, Y.Kawasaki
 * All rights reserved.
 * $Id$
 * -------------------------------------------------------------------------
 */
#ifndef _MTRACEMAIN_OPTF1V4_H
#define _MTRACEMAIN_OPTF1V4_H

#include <stdio.h>
//#include "Rtypes.h"

#define MFS_TOLERANCE   0.01  /* mm */
#define MFS_DEF_STEP    0.1   /* mm */
#define MFSLOOP_MAX      100

typedef struct _Mtel_param{
  double Mr_lens, Mr_wall, Mr_fs;
  double Mr_cut[9];
  double MSz0;
  double MRc1,MSz1,MZc1;
  double MRc2,MSz2,MZc2;
  double MRc4,MSz4,MZc4;
  double MRc6,MSz6,MZc6;
  double MRc7,MSz7,MZc7;
  double MZc3,MRc3;
  double MZcD,MRcD;
  double MFS_C, MFS_K, MFSA, MFSB, MFSC, MFSD, MFS_OFFSET; /* for FS */
  double Mlambda0; /* nm */
  char Mlens_dir[256];
} Mtel_param;

int Mread_tel_param(const char *filename, Mtel_param *param, FILE *fplog);
int Mprint_param(Mtel_param *p);
int Mtrace_main(Mtel_param *param,
               double ph_in[8], double ph_out[8], FILE *fplog);
double MFocalSurface(double r, Mtel_param *p);

#endif
