// $Id: LIdealFocalSurface.hh 2828 2009-04-01 14:29:16Z biktem $
// Author: Dmitry V.Naumov  2007/11/16

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: NIdealFocalSurface                                                   *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

#ifndef __NIDEALFOCALSURFACE_HH__
#define __NIDEALFOCALSURFACE_HH__

#include "euso.hh"
#include "IdealFocalSurface.hh"
#include "EsafMsgSource.hh"
#include "VirtualTelParm.hh"
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// NIdealFocalSurface                                                         //
//                                                                            //
// <brief class description>                                                  //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

class NIdealFocalSurface : public IdealFocalSurface, public EsafMsgSource, public VirtualTelParm   {
public:
    NIdealFocalSurface();
    virtual ~NIdealFocalSurface();

    virtual Bool_t HitPosition(Photon *p);

    virtual Double_t Profile( Double_t r);

    EsafConfigClass(Optics,NOpticalSystem)

private:
    Double_t Zfs(Double_t r);
    Double_t fRho, fK, fA, fB, fC, fD;  // FS parameters
    Double_t fPrec;                     // precision required to claim
                                        // that the photon has hit the FS

    ClassDef(NIdealFocalSurface,0)
};

#endif  /* __MIDEALFOCALSURFACE_HH__ */