// $Id: NOpticalSystem.hh 2784 2010-11-05 10:19:08Z biktem $
// Author: Dmitry V.Naumov   2007/11/13

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: NOpticalSystem                                                       *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

#ifndef __NOPTICALSYSTEM_HH__
#define __NOPTICALSYSTEM_HH__

#include "euso.hh"
#include "OpticalSystem.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// NOpticalSystem                                                             //
//                                                                            //
// <brief class description>                                                  //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////


class NOpticalSystem : public OpticalSystem{
public:
    NOpticalSystem();
    virtual ~NOpticalSystem();
    virtual Photon* Transport(Photon *p) const;
    virtual Bool_t HitSide(Photon *p) const;

    EsafConfigClass(Optics,NOpticalSystem)

private:
    // checks if a not 0 flag photon is going out
    Bool_t IsGoingOut(Photon *p) const;



    //FILE*                        fLogFile;
    ClassDef(NOpticalSystem,0)
};

#endif  /* __MOPTICALSYSTEM_HH__ */
