/* -------------------------------------------------------------------------
 *   NPhoton.h
 *
 *   --- header file for NPhoton.c
 *
 * Copyright (c) 2010 N.Sakaki, Y.Takizawa, Y.Kawasaki
 * All rights reserved.
 * $Id$
 * -------------------------------------------------------------------------
 */
#ifndef _PHOTON_H
#define _PHOTON_H

/* speed of light in mm/ns */
//#define C0 299.792458
namespace NTraceLens{

typedef struct _PhPosition{
  double x[3];
  double t;
  struct _PhPosition *next;
} PhPosition;

typedef struct _Photon{
  double x[3];
  double px[3];
  double t;
  double lambda;
  PhPosition *history;
  int id;
} NPhoton;

int StorePhotonHistory(NPhoton *p);
int DeletePhoton(NPhoton *p);
int ShowPhotonHistory(NPhoton *p);
int SetPhotonDirection(NPhoton *p, double ex, double ey, double ez);
int SetPhotonPosition(NPhoton *p, double x, double y, double z, double t);
int MovePhoton(NPhoton *p, double dist, double rindex);
int ClearPhotonHistory(NPhoton *p);
}
#endif
