// $Id: Photon.hh 2855 2010-11-25 15:47:14Z biktem $
// Author: D.DeMarco

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: Photon                                                               *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

#ifndef __PHOTON_HH__
#define __PHOTON_HH__

#include "EVector.hh"

class ParentPhoton;

enum {
    X = 0,
    Y = 1,
    Z = 2
};

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Photon                                                                     //
//                                                                            //
// The photon class is the basic element of the optics simulation and holds   //
// the parameters of the photon being tracked.                                //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

class Photon {
public:
    Double_t time;
    Double_t wl;  //mm
    EVector pos, dir;
    EVector posOnIfs;
    Int_t pixelUid;
    Int_t iterations;
    Int_t history;
    Int_t fate;
    Bool_t hit;
    Bool_t hitIfs;
    Bool_t MChit;
    Bool_t madeSignal;
    ParentPhoton *parent;
    Int_t id;
    Photon();
    virtual ~Photon();

    void Dump() const;

    ClassDef(Photon,0)
};

#endif /* __PHOTON_HH__ */
