// ESAF : Euso Simulation and Analysis Framework
// $Id: PipesOpticalAdaptor.hh 1326 2004-12-23 00:39:46Z thea $
// A.Thea created Nov,  8 2002

#ifndef __PIPESOPTICALADAPTOR_HH_
#define __PIPESOPTICALADAPTOR_HH_

#include "euso.hh"
#include "OpticalAdaptor.hh"
#include "LightPipe.hh"
#include "PmtGeometry.hh"
#include "EVector.hh"



class PipesOpticalAdaptor : public OpticalAdaptor {
public:
    PipesOpticalAdaptor();
    virtual ~PipesOpticalAdaptor();
    virtual Photon *Transport(Photon *) const;
    void SetPipesGeometry();
    
protected:
    static int _nrows;   // number of pipes per row
    static int _npads;   // number of pipes
    static double _pad_side;  // side length of the top face of the pipes
    static double _bottom_inner_strip;  // gap between the bottom faces of the pipes
    static double _bottom_pad_side;  // side length of the bottom face of the pipes
    static EVector _corners[10][10][2];  // corners positions in loocal coordinates

    EsafConfigClass(Optics,PipesOpticalAdaptor)

    ClassDef(PipesOpticalAdaptor,0)
};

#endif  /* __PIPESOPTICALADAPTOR_HH_ */

