// $Id: SphericalIdealFocalSurface.hh 1726 2005-04-14 21:49:58Z thea $
// Author: A.Thea   2005/01/16

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: SphericalIdealFocalSurface                                           *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

#ifndef __SPHERICALIDEALFOCALSURFACE_HH__
#define __SPHERICALIDEALFOCALSURFACE_HH__

#include "euso.hh"
#include "IdealFocalSurface.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// SphericalIdealFocalSurface                                                 //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class SphericalIdealFocalSurface : public IdealFocalSurface {
public:
    SphericalIdealFocalSurface();
    virtual ~SphericalIdealFocalSurface();

    virtual Bool_t HitPosition(Photon *p);
    
    virtual Double_t Profile( Double_t r);
    
    EsafConfigClass(Optics,SphericalIdealFocalSurface)

private:
    Double_t Zfs(Double_t r);
    Double_t fSphRadius;    // radius of the sphere
    Double_t fPrec;                     // precision required to claim 
                                        // that the photon has hit the FS

    ClassDef(SphericalIdealFocalSurface,0)
};

#endif  /* __SPHERICALIDEALFOCALSURFACE_HH__ */

