// ESAF : Euso Simulation and Analysis Framework
// $Id: ERunParsPixelMapFiller.cc 767 2004-06-16 13:06:46Z thea $
// Alessandro Thea created Dec, 18 2003

#include "ERunParsPixelMapFiller.hh"
#include "ERunParameters.hh"
#include "EusoMapping.hh"
#include <iostream>

ClassImp(ERunParsPixelMapFiller)

// ctor
ERunParsPixelMapFiller::ERunParsPixelMapFiller() {
}

// dtor
ERunParsPixelMapFiller::~ERunParsPixelMapFiller() {
}

// filler
void ERunParsPixelMapFiller::Fill( ERunParameters *p ) { 

    EusoMapping *oldmap = EusoMapping::Get();

    // copy EusoMapping array into ERunParameters
    EAnglePixelMap& map = p->fAnglePixelMap;
    map.Resize(oldmap->GetPixelsNumber());
    
    for( Int_t i(0); i < map.GetNumPixels(); i++) {

        map.fThetaFOV[i] = oldmap->GetThetaFOV(i+1);
        map.fSigmaThetaFOV[i] = oldmap->GetSigmaThetaFOV(i+1);
        map.fPhiFOV[i] = oldmap->GetPhiFOV(i+1);
        map.fSigmaPhiFOV[i] = oldmap->GetSigmaPhiFOV(i+1);

    }

}
