// ESAF : Euso Simulation and Analysis Framework
// $Id: FakeOpticalAdaptor.cc 2439 2006-01-31 18:28:30Z naumov $
// A.Thea created Oct, 24 2003

#include "FakeOpticalAdaptor.hh"
#include "Photomultiplier.hh"
using namespace sou;

ClassImp(FakeOpticalAdaptor)

//______________________________________________________________________________
FakeOpticalAdaptor::FakeOpticalAdaptor() {
    // 
    // Constructor
    // 

    fReflectivity = Conf()->GetNum("FakeOpticalAdaptor.fCathode.reflectivity");

    fSide=Conf()->GetNum("FakeOpticalAdaptor.fSide")*mm;
    fHeight=Conf()->GetNum("FakeOpticalAdaptor.fHeight")*mm;
}

//______________________________________________________________________________
FakeOpticalAdaptor::~FakeOpticalAdaptor() {
    // 
    // Destructor
    // 

}

//______________________________________________________________________________
Photon *FakeOpticalAdaptor::Transport(Photon *p) const {
    EVector lpos, ldir;
    lpos=p->pos-fPos;
    lpos=goLocal(lpos);
    ldir=goLocal(ldir);

    Int_t face=whichFace(p);
    if ( face == TOP ){

        if (isReflectedByCathode()) {
            EVector ldir=goLocal(p->dir);
            ldir[Z]*=-1;
            p->dir=goGlobal(ldir);
            p->MChit=false;
            p->hit=false;
            return Transport(p);        
        }

        // Add photon to PMT
        pmt->Pmt()->Add(*p);

        // photon absorbed, no further tracking required.
        return 0;
        
    } else if ( face == BOTTOM ) {
        return p;
    } else{
        MsgForm(EsafMsg::Panic,"FakeOpticalAdaptor: photon on a non-existent face.");
    }
    return 0;
}
