// $Id: Photon.cc 2855 2010-11-25 15:47:14Z biktem $
//

// Author: A.Thea   2004/07/19

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: Photon                                                               *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

//_____________________________________________________________________________
//
//   Photon
//   ======
//

#include "Photon.hh"

ClassImp(Photon)

//______________________________________________________________________________
Photon::Photon(): time(0), wl(0), pos(0,0,0), dir(0,0,1), posOnIfs(0,0,0),
    pixelUid(-1), iterations(0), history(0), fate(0), hit(kFALSE),
    hitIfs(kFALSE), MChit(kFALSE), madeSignal(kFALSE), parent(0),id(-1) {
    //
    // Constructor
    //
}

//______________________________________________________________________________
Photon::~Photon() {
    //
    // Destructor
    //
}

//______________________________________________________________________________
void Photon::Dump() const {
    //
    // Dump photon status
    //

	cout << "-Ph---------------------------------" << endl;
	cout << " ph.time:        " << time		   << endl;
	cout << " ph.wl:          " << wl          << endl;
	cout << " ph.iterations:  " << iterations  << endl;
	cout << " ph.history:     " << history     << endl;
	cout << " ph.fate:        " << fate        << endl;
	cout << " ph.hit:         " << hit         << endl;
	cout << " ph.hitIfs:      " << hitIfs	   << endl;
	cout << " ph.MChit:       " << MChit       << endl;
	cout << " ph.madeSignal:  " << madeSignal  << endl;
	cout << " ph.pixelUid:    " << pixelUid    << endl;
	cout << " ph.parent:      " << parent      << endl;
    cout << "ph.dir:" << endl;
    cout << Form(" X = %.30E\n Y = %.30E\n Z = %.30E",
            dir[X],dir[Y],dir[Z]) << endl;
    cout << "ph.pos:" << endl;
    cout << Form(" X = %.30E\n Y = %.30E\n Z = %.30E",
            pos[X],pos[Y],pos[Z]) << endl;
    cout << "ph.posOnIfs:" << endl;
    cout << Form(" X = %.30E\n Y = %.30E\n Z = %.30E",
            posOnIfs[X],posOnIfs[Y],posOnIfs[Z]) << endl;
	cout << "------------------------------------" << endl;
}

