#include"VirtualTelParm.hh"

#include "Ntrace_lenses.hh"
using namespace NTraceLens;
ClassImp(VirtualTelParm)
NTraceLens::tel_param* VirtualTelParm::fOpticalSystemParam = 0;

VirtualTelParm::VirtualTelParm():fLogFile(0){

}

VirtualTelParm::~VirtualTelParm(){
    if(fOpticalSystemParam) delete fOpticalSystemParam;
    fOpticalSystemParam=0;
}

int VirtualTelParm::ReadTelParm(const char* lens_dir,const char* name){

    if(fOpticalSystemParam)return 1;

    fOpticalSystemParam = new NTraceLens::tel_param();

    if(read_tel_param(Form("%s/%s.dat",lens_dir,name),fOpticalSystemParam,fLogFile)!=0){
        fprintf(stderr,"reading tel_param data files failed\n");
        return 0;
    }

    if(ReadLensData(fOpticalSystemParam,fLogFile)<0) {
       fprintf(stderr,"reading lens surface data files failed\n");
       return 0;
    }
    if(ReadDiffractData(fOpticalSystemParam,fLogFile)<0) {
       fprintf(stderr,"reading diffractive opt. data files failed\n");
       return 0;
    }

    return 2;

}
