// $Id: econfig.c 2828 2009-04-01 14:29:16Z biktem $
// A.Thea, created Sep, 24 2004

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: econfig                                                              *
 *  Package: Externals                                                       *
 *  Coordinator:                                                             *
 *                                                                           *
 *****************************************************************************/

//_____________________________________________________________________________
//
//  Euso Random fortran interface
//
//  Function names follow the convention
//
//  esaf[TRandom method][typeid]_(...)

#include "ConfigFileParser.hh"
#include "Config.hh"
#include <string.h>
#include <cstring>
#include <iostream>

extern "C"   void esafconfigpath_( char* path, int path_len );
extern "C"   void esafgetstr_( char* path, int path_len, const char* dname, const char* cname, const char* vname,
                               int dname_len, int cname_len, int vname_len );
extern "C" double esafgetdouble_( const char* dname, const char* cname, const char* vname,
                                  int dname_len, int cname_len, int vname_len );
extern "C"    int esafgetbool_( const char* dname, const char* cname, const char* vname,
                                int dname_len, int cname_len, int vname_len );

void esafconfigpath_( char* path, int path_len ) {

    string cfgpath = ConfigFileParser::GetCfgDir();
    strncpy(path,cfgpath.c_str(),path_len);

}

extern "C" void esafgetstr_(  char* val, int val_len, const char* dname, const char* cname, const char* vname, int dname_len, int cname_len, int vname_len ) {

    char edir[300], eclass[300], evar[300];
    strncpy(edir,dname,dname_len);
    strncpy(eclass,cname,cname_len);
    strncpy(evar,vname,vname_len);

    edir[dname_len]='\0';
    eclass[cname_len]='\0';
    evar[vname_len]='\0';

    string str = Config::Get()->GetCF(edir,eclass)->GetStr(evar);
    strncpy(val,str.c_str(),val_len);
}

extern "C" double esafgetdouble_( const char* dname, const char* cname, const char* vname, int dname_len, int cname_len, int vname_len ) {

    char edir[300], eclass[300], evar[300];
    strncpy(edir,dname,dname_len);
    strncpy(eclass,cname,cname_len);
    strncpy(evar,vname,vname_len);

    edir[dname_len]='\0';
    eclass[cname_len]='\0';
    evar[vname_len]='\0';

    return Config::Get()->GetCF(edir,eclass)->GetNum(evar);
}

extern "C" int esafgetbool_( const char* dname, const char* cname, const char* vname, int dname_len, int cname_len, int vname_len ) {

    char edir[300], eclass[300], evar[300];
    strncpy(edir,dname,dname_len);
    strncpy(eclass,cname,cname_len);
    strncpy(evar,vname,vname_len);

    edir[dname_len]='\0';
    eclass[cname_len]='\0';
    evar[vname_len]='\0';

    return (int)Config::Get()->GetCF(edir,eclass)->GetBool(evar);
}
