*     ... This is the US Standard atmosphere density ...
*     ... INPUT:  height in km                       ...
*     ... OUTPUT: air density in g/cm^2/km           ...
*     ... AUTHOR: D.V. NAUMOV                        ...
*     ... DATE:   08.06.2002                         ... 
      REAL FUNCTION ATM2(h)
#include "detector.inc"
      REAL B(5), C(5)
      DATA B/1222.6562,1144.9069,1305.5948,540.1778,1./    ! g/cm^2
      DATA C/9.9418638,8.7815355,6.3614304,7.7217016,1.e4/ ! km

      Hkm = h                   ! in km
      IF(Hkm.LE.4.)                  ATM2 = B(1)/C(1)*EXP(-h/C(1))
      IF(4..LT.Hkm.AND.Hkm.LE.10.)   ATM2 = B(2)/C(2)*EXP(-h/C(2))
      IF(10..LT.Hkm.AND.Hkm.LE.40.)  ATM2 = B(3)/C(3)*EXP(-h/C(3))
      IF(40..LT.Hkm.AND.Hkm.LE.100.) ATM2 = B(4)/C(4)*EXP(-h/C(4))
      IF(Hkm.GT.100.)                ATM2 = B(5)/C(5)
*
      END
