*
*     ... THIS FUNCTION RETURNS THE DEPTH IN THE ATMOSPHERE ...
*     ... BETWEEN THE POINT WITH RADIUS_VECTOR R(3) AND THE ...
*     ... INTERACTION POINT
*     ... DATE: 3.06.2002
*     ... AUTHOR: D.V. NAUMOV
*
      REAL FUNCTION DEPTH_R_RINT(R)
      IMPLICIT NONE
#include "detector.inc"
#include "event.inc"
      REAL R(3), PI, HALF_PI, Hstar, H_INT,THETA_INT,H_R,THETA_R
      REAL DEPTH_R, DEPTH_INT, DEPTH_INTEGRAL,EPS
*
      PI      = ACOS(-1.)
      EPS = 1.e-3
      HALF_PI = PI/2 -EPS
*     
      CALL IMPACT(R,Hstar,H_INT,THETA_INT,H_R,THETA_R)
      IF(THETA_R.LE.HALF_PI) THEN
         DEPTH_R = DEPTH_INTEGRAL(THETA_R,H_R)
      ELSE
         THETA_R = PI - THETA_R
         DEPTH_R = 2*DEPTH_INTEGRAL(HALF_PI,Hstar)-
     +        DEPTH_INTEGRAL(THETA_R,H_R)
      ENDIF
*     
      IF(THETA_INT.LE.HALF_PI) THEN
        DEPTH_INT = DEPTH_INTEGRAL(THETA_INT,H_INT)
      ELSE
         THETA_INT = PI - THETA_INT
         DEPTH_INT = 2*DEPTH_INTEGRAL(HALF_PI,Hstar)-
     +        DEPTH_INTEGRAL(THETA_INT,H_INT)
         
      ENDIF
      DEPTH_R_RINT  = DEPTH_R - DEPTH_INT
      IF(DEPTH_R_RINT.LT.0.) DEPTH_R_RINT = 0.
 1000 CONTINUE
      END
