      SUBROUTINE DO_FLUORESCENCE(Lc,L_step,Ne,S,Nfl)
      IMPLICIT NONE
#include "detector.inc"      
#include "event.inc"
#include "refractive.inc"

*     ... EXTERNAL FUNCTIONS ...
      REAL DEPTH_R_ISS,ATM,REFRACTIVE_INDEX, CHERENKOV_THRESHOLD
      REAL FLUOR_YIELD
*     ... INPUT VARIABLES ...
      REAL Lc,L_step,Ne,S
*     ... OUTPUT VARIABLES ...
      REAL Nfl,TR,TM
*     ... LOCAL VARIABLES ...
      REAL R(3),RTOISS(3),cos_R_ISS,TFINAL,H
      REAL PI,factor,SCALAR_ISS_RTOISS,SCALAR_ISS,SCALAR_RTOISS
      REAL SCALAR_R
      
      IF(FL_FLAG.NE.1) RETURN

*     ... SOME CONSTANTS ...
      PI = ACOS(-1.)
*     ... CURRENT POINT ...
      R(1)  = RINT(1) - (Lc+L_step/2)*SIN(THETA)*COS(PHI)
      R(2)  = RINT(2) - (Lc+L_step/2)*SIN(THETA)*SIN(PHI)
      R(3)  = RINT(3) - (Lc+L_step/2)*COS(THETA)
      CALL VECTORDOT(3,R,R,SCALAR_R)
      H = SQRT(SCALAR_R) - R_EARTH
*     ... RTOISS = ISS - RG
      CALL VECTORLIB(3,'-',ISS,R,RTOISS)
      CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
      CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
      CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
      IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
         cos_R_ISS  = SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
      ELSE
         cos_R_ISS  = 0.
      ENDIF
      factor = SDIA**2*cos_R_ISS/SCALAR_RTOISS/16/1.e6
*
      Nfl = FLUOR_YIELD(S,H)*Ne*factor*L_step*1.e3
*
      END
