      SUBROUTINE INIT
#include "detector.inc"
#include "event.inc"
#include "shower.inc"
*
      INTEGER*4 KEYSIZ
      PARAMETER (KEYSIZ=8)
      COMMON/CFREAD/SPACE(1000)
      CALL FFINIT(1000)
*
      CALL FFSET('LINP',10)
      CALL FFSET('LOUT',11)
      CALL FFSET('SIZE',KEYSIZ)
*     ... DEFINE INPUT/OUTPUT FILES
      OPEN (UNIT=10,FILE='auxilar/global.datacard',STATUS='OLD')
      OPEN (UNIT=11,FILE='auxilar/ffkey.check',STATUS='UNKNOWN')
*     ... SET UP SOME DEFAULT VALUES ...
      ARES = 0.01
      SPEC = 0
      DEPT = 0
      IMIE = 0
      IFLU = 0
      LWTR = 0
      TRAN = 1
      QEFF = 0.20
      THRESHOLD = 5.
      NEVT = 1
      TYPER = 1
      ZNUC = 1
      INTE = 1
      POWE = 2.7
      ERAN = 1
      ESAF = 0
*     ... DETECTOR AND ATMOSPHERE KEYS ...
      CALL FFKEY('ERAD',R_EARTH,1,'REAL')
      CALL FFKEY('FOV',FOV,1,'REAL')
      CALL FFKEY('ARES',ANG_RES,1,'REAL')
      CALL FFKEY('WAVE',WAVE,2,'REAL')
      CALL FFKEY('ATMO',ATMO,1,'REAL')
      CALL FFKEY('TEMP',TEMP,1,'REAL')
      CALL FFKEY('DEPT',DEPT,1,'REAL')
      CALL FFKEY('IMIE',IMIE,1,'REAL')
      CALL FFKEY('IFLU',IFLU,1,'REAL')
      CALL FFKEY('DIST',DIST,1,'REAL')
      CALL FFKEY('SPEC',SPEC,1,'REAL')
      CALL FFKEY('LWTR',LWTR,1,'REAL')
      CALL FFKEY('TRAN',TRAN,1,'REAL')
      CALL FFKEY('ALBE',ALBEDO,1,'REAL')
      CALL FFKEY('GTU',GTU,1,'REAL')
      CALL FFKEY('QEFF',QEFF,1,'REAL')
      CALL FFKEY('CURV',CURV,1,'REAL')
      CALL FFKEY('THRE',THRESHOLD,1,'REAL')
*     ... EVENT KEYS ...
      CALL FFKEY('NEVT',NEVT,1,'REAL')
      CALL FFKEY('DOCH',CH_FLAG,1,'REAL')
      CALL FFKEY('DOFL',FL_FLAG,1,'REAL')
      CALL FFKEY('RINT',RINT,3,'REAL')
      CALL FFKEY('THET',THETAR,2,'REAL')
      CALL FFKEY('PHI', PHIR,2,'REAL')
      CALL FFKEY('EINT',EINTR,2,'REAL')
      CALL FFKEY('TYPE',TYPER,1,'REAL')
      CALL FFKEY('ZNUC',ZNUC,1,'REAL')
      CALL FFKEY('INTE',INTTYPE,1,'REAL')
      CALL FFKEY('QCDC',QCDCORR,1,'REAL')
      CALL FFKEY('SHOW',SHOW,1,'REAL')
      CALL FFKEY('POWE',POWER,1,'REAL')
      CALL FFKEY('ERAN',ERAN,1,'REAL')
      CALL FFKEY('ESAF',ESAF,1,'REAL')
*
      CALL FFGO
      CLOSE (10)
      CLOSE (11)
*
      WRITE(16,1) 'global.datacard'
      WRITE(16,2) 'ffkey.check'
 1    FORMAT(1x,'=====>',1x,'INITIALIZATION WORDS ARE READ FROM',1x,
     +     A)
 2    FORMAT(1x,'=====>',1x,'CHECK',1x,A,1x,'FILE')
      END

      SUBROUTINE SLASTDETECTORGEOMETRY(Radius,ISSX,ISSY,ISSZ)
#include "detector.inc"
      REAL Radius,ISSX,ISSY,ISSZ
      SDIA = 2*Radius 
      ISS(1) = ISSX
      ISS(2) = ISSY
      ISS(3) = ISSZ
      END
