      SUBROUTINE DEVELOP_ESAFSHOWER(Lmax,KEY_TRIG)
#include "event.inc"
#include "shower.inc"
#include "detector.inc"
#include "erandom.inc"
#include "constants.inc"
#include "esafoutput.inc"
*     ... EXTERNAL FUNCTIONS ...
      REAL DEPTH_R_RINT, ATM
*     ... INPUT VARIABLES    ...
      REAL Lmin, Lmax
*     ... OUTPUT VARIABLES    ...
      LOGICAL KEY_TRIG
*     ... LOCAL VARIABLES    ...
      REAL L_step, L, R(3),R1(3), RG(3), Ne1, Ne1max, s, d, t, time_ch
      REAL ACC,D3,RTMP(3), L_substep, TRANS(100), L_GTU
      INTEGER Nph,N,avoid_cycling,k_bunch,kCYCLING
      REAL RTOISS(3),SCALAR_ISS_RTOISS,SCALAR_ISS,SCALAR_RTOISS
      REAL cos_R_ISS,w,RIMPACT1,ALPHAIMPACT1,theta1c,phi1c
      REAL ATTENUATION_CHERENKOV, ch_angle, time_corrected, time_sigma
      REAL ShowerTimer,Ri(3),Rf(3),rndm
*     ... EXCHANGE WITH DO_CHERENKOV ...
      REAL NchISS
      REAL TRG,TMG,TRS,TMS
      REAL TR_G,TM_G,TR_G_ISS,TM_G_ISS,time_ch1d
*     ... EXCHANGE WITH DO_FLUORECENCE ...
      REAL Nfl1,time_fl1d
*     ... EXCHANGE WITH IMPACT ...
      REAL Hstar,H_INT,THETA_INT,H_R,THETA_R
      WRITE(6,200) 'SLAST IS GENERATING PHOTONS(pixel = 2000 photons) '
      k_bunch=0
      avoid_cycling = 0
      kCYCLING = 100000
      Ne1max = 0
      CALL ESAF_RESET
* ... Fill header information
      ShowerEnergy = EINT
      ShowerTheta  = THETA
      ShowerPhi    = PHI
      ShowerX1     = X1
      ShowerRint(1)= RINT(1)*1000 ! m 
      ShowerRint(2)= RINT(2)*1000 ! m
      ShowerRint(3)= (RINT(3)-R_EARTH)*1000 ! m

*     ... SOME DEFAULTS FOR   ACCEPTANCE_TYPE.NE.1.
      DO i = 1, 3
        RG(i) = 10000.
      ENDDO

      ShowerHitGround = 0
      IF(ACCEPTANCE_TYPE.EQ.1.) ShowerHitGround = 1.E0
*     ... COMPUTE CHERENKOV INFORMATION ...

      IF(ACCEPTANCE_TYPE.EQ.1.) THEN
        RG(1) = RINT(1) - Lmax*SIN(THETA)*COS(PHI)
        RG(2) = RINT(2) - Lmax*SIN(THETA)*SIN(PHI)
        RG(3) = RINT(3) - Lmax*COS(THETA)      
        CALL VECTORLIB(3,'-',ISS,RG,RTOISS)
        CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
        CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
        CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
        
        IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
          cos_R_ISS  = 
     +         SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
        ELSE
          cos_R_ISS  = 0.
        ENDIF
*     ... ARRIVAL ANGLES ...
        IF(ABS(cos_R_ISS).GT.1.) cos_R_ISS = 1.
        theta1c = ACOS(cos_R_ISS)/PI*180
        IF(RG(1).NE.0.) THEN
          phi1c = ATAN2(RG(2),RG(1))/PI*180
        ELSE
          phi1c = 90.0
        ENDIF
*     ... ARRIVAL TIME ...
        time_ch =  10./3*(Lmax+SQRT(SCALAR_RTOISS))
      ENDIF

      ShowerImpact(1) = RG(1)*1000 ! in m
      ShowerImpact(2) = RG(2)*1000 ! in m
      ShowerImpact(3) = (RG(3)-R_EARTH)*1000 ! in m
      
      d    = DEPTH_R_RINT(RG)
      CALL SHOWER_PARAMETRIZATION(d,Ne1,t,s)
      ShowerAgeEarth = s
      
*     ... START TO DEVELOP SHOWER ...
      L_GTU  = 3.e-1*GTU/2 ! minimal GTU timing
      L_step = L_GTU       ! attention!!!

*     ... ACCEPTANCE TYPE ...
      ACC = ACCEPTANCE_TYPE
      Lmin = 0.
      IF(ACC.NE.1.) THEN
        D3 = RINT(1)**2+RINT(2)**2-RINT(3)**2*TAN(FOV)**2
        IF(D3.LT.0.) THEN
          Lmin = 0.             ! already inside FOV
        ELSE
          Lmin = SQRT(RINT(3)**2+SQRT(D3))
        ENDIF
      ENDIF
*
      ShowerTimer = 0
      DO L = Lmin, Lmax, L_step ! L      is in km
         IF(L.GT.Lmax) GOTO 100
         SN = SN + 1 ! number of steps in the Shower
         IF(SN.GT.Nsh) THEN
           WRITE(6,*) 'SLAST DEVELOP_ESAFSHOWER() :' 
           WRITE(6,*) 'WARNING:Number of Steps exceeds MAXIMUM.'
           WRITE(6,*) 'TRUNCATE THE SHOWER'
           GOTO 33
         ENDIF 
         ShowerTimei(SN) = ShowerTimer
         ShowerTimef(SN) = ShowerTimei(SN) + 10.E0/3*L
         ShowerTimer     = ShowerTimef(SN)
*     ... DEFINE CURRENT POSITION OF THE SHOWER ...

*     ... MEAN POSITION ...         
        R(1) = RINT(1) - (L+L_step/2)*SIN(THETA)*COS(PHI)
        R(2) = RINT(2) - (L+L_step/2)*SIN(THETA)*SIN(PHI)
        R(3) = RINT(3) - (L+L_step/2)*COS(THETA)
*     ... INIT POINT ...
        Ri(1) = RINT(1) - L*SIN(THETA)*COS(PHI)
        Ri(2) = RINT(2) - L*SIN(THETA)*SIN(PHI)
        Ri(3) = RINT(3) - L*COS(THETA)
        ShowerRxi(SN) =  Ri(1)*1000 ! in m
        ShowerRyi(SN) =  Ri(2)*1000 ! in m
        ShowerRzi(SN) = (Ri(3)-R_EARTH)*1000 ! in m
*     ... END POINT ...
        Rf(1) = RINT(1) - (L+L_step)*SIN(THETA)*COS(PHI)
        Rf(2) = RINT(2) - (L+L_step)*SIN(THETA)*SIN(PHI)
        Rf(3) = RINT(3) - (L+L_step)*COS(THETA)
        ShowerRxf(SN) =  Rf(1)*1000 ! in m
        ShowerRyf(SN) =  Rf(2)*1000 ! in m
        ShowerRzf(SN) = (Rf(3)-R_EARTH)*1000 ! in m
        CALL VECTORLIB(3,'-',ISS,R,RTOISS)
        CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
        CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
        CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
        
        IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
          cos_R_ISS  = 
     +         SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
        ELSE
          cos_R_ISS  = 0.
        ENDIF
        IF(ABS(cos_R_ISS).GT.1.) cos_R_ISS = 1.
        IF(ACOS(cos_R_ISS).LE.FOV) THEN
          in_fov = 1
        ENDIF
        ShowerXi(SN) = DEPTH_R_RINT(Ri)
        ShowerXf(SN) = DEPTH_R_RINT(Rf)
        CALL SHOWER_PARAMETRIZATION(ShowerXi(SN),Ne1,t,s)
        ShowerAgei(SN) = s
        CALL SHOWER_PARAMETRIZATION(ShowerXf(SN),Ne1,t,s)
        ShowerAgei(SN) = s
        d    = DEPTH_R_RINT(R)
        CALL IMPACT(R,Hstar,H_INT,THETA_INT,H_R,THETA_R)
        CALL SHOWER_PARAMETRIZATION(d,Ne1,t,s)
        ShowerNe(SN) = Ne1
        IF(Ne1.GT.Ne1max) THEN
          Ne1max        = Ne1
          ShowerXmax    = DEPTH(R)
          ShowerRmax(1) = R(1)*1000 ! in m
          ShowerRmax(2) = R(2)*1000 ! in m
          ShowerRmax(3) = (R(3)-R_EARTH)*1000 ! in m
        ENDIF

*     ... STOP TO DEVELOP SHOWER IF IT IS OUTSIDE THE FOV ...
        IF(ACOS(cos_R_ISS).GT.FOV.AND.in_fov.EQ.1) GOTO 33

*      ... FLUORESCENCE OUTPUT OF INDIVIDUAL PHOTONS ...
        IF(ACOS(cos_R_ISS).LE.FOV) THEN
          CALL DO_FLUORESCENCE(L,L_step,Ne1,S,Nfl1)
	  N = ESAFPOISSON(DBLE(Nfl1))
	  IF (avoid_cycling.GT.kCYCLING) GOTO 33
          IF(N.EQ.0) THEN
             avoid_cycling = avoid_cycling + 1
             GOTO 2
          ENDIF
*     ... DEFINE END POINTS VECTORS ...
          
          R1(1) = RINT(1) - L*SIN(THETA)*COS(PHI)
          R1(2) = RINT(2) - L*SIN(THETA)*SIN(PHI)
          R1(3) = RINT(3) - L*COS(THETA)

          L_substep = L_step/N
          CALL TRANSITION_R_ISS(R1,TRANS)
          DO i = 1, N
*     ... GENERATE UNIFORM POINT ALONG THE TRACK L_step ... 
            rndm = ESAFRNDM()
            X = R1(1)-L_substep*SIN(THETA)*COS(PHI)*(1.*(i-1)+RNDM)
            Y = R1(2)-L_substep*SIN(THETA)*SIN(PHI)*(1.*(i-1)+RNDM)
            Z = R1(3)-L_substep*COS(THETA)*(1.*(i-1)+RNDM)
            RTMP(1) = X
            RTMP(2) = Y
            RTMP(3) = Z
*     ... PHOTON WAVELENGTH ...
            CALL FLUOR_SPECTRUM(w)
            TFINAL = GETTRANSITION(TRANS,w)
            RNDM = ESAFRNDM()
            IF(RNDM.GT.TFINAL) GOTO 111
            FN = FN + 1
            CALL VECTORLIB(3,'-',ISS,RTMP,RTOISS)
            CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
            CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
            CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
        
            IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
              cos_R_ISS  = 
     +             SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
             ELSE
              cos_R_ISS  = 0.
            ENDIF
            
*     ... TRANSFORM TO MAIN EUSO SYSTEM FRAME ...
            X = X*1000          ! in m
            Y = Y*1000          ! in m
            Z = (Z-R_EARTH)*1000 !in m 
*     ... ARRIVAL TIME ...
            time_fl1d = 10./3*(L+L_substep*(1.e0*(i-1)+ESAFRNDM())
     &           +SQRT(SCALAR_RTOISS))
            theta1 = ACOS(cos_R_ISS)/PI*180
            IF(X.NE.0.) THEN
              phi1 = ATAN2(Y,X)/PI*180
            ELSE
              phi1 = 90.0
            ENDIF
*     ... RADIAL DISTANCE OF THE PHOTON IMPACT POINT ON THE FIRST ...
*     ... FRESNEL LENS SURFACE                                    ...
            CALL SURFACE_POINT(RIMPACT1,ALPHAIMPACT1)
*     ... PREPARE ESAF OUTPUT: ...
            FXshower(FN) = X
            FYshower(FN) = Y
            FZshower(FN) = Z
            FXfocal(FN)  = RIMPACT1*COS(ALPHAIMPACT1/180*PI)
            FYfocal(FN)  = RIMPACT1*SIN(ALPHAIMPACT1/180*PI)
            FZfocal(FN)  = 0
            Ftheta1(FN)  = theta1
            Fphi1(FN)    = phi1
            Flambda(FN)  = w
            Ftime(FN)    = time_fl1d
            k_bunch = k_bunch+1
            IF(k_bunch.EQ.2000) THEN
               WRITE(6,200) '.' 
               k_bunch=0
            ENDIF
 111      ENDDO
        ENDIF
*
*        
*     ... CHERENKOV OUTPUT OF INDIVIDUAL PHOTONS ...
*
*
 2      IF(ACCEPTANCE_TYPE.NE.1.) GOTO 3
        CALL DO_CHERENKOV(L,Lmax,L_step,S,Ne1,NchiSS)
        N = ESAFPOISSON(DBLE(NchISS))
        IF (avoid_cycling.GT.kCYCLING) GOTO 33
            IF(N.EQ.0) THEN
               avoid_cycling = avoid_cycling + 1
             GOTO 3
        ENDIF
        L_substep = L_step/N
        CALL TRANSITION_R_RINT_ISS(R1,RG,TRANS)
        DO i = 1, N
*     ... GENERATE UNIFORM POINT ALONG THE TRACK L_step ... 
          RNDM = ESAFRNDM()
          X = R1(1)-L_substep*SIN(THETA)*COS(PHI)*(1.*(i-1)+RNDM)
          Y = R1(2)-L_substep*SIN(THETA)*SIN(PHI)*(1.*(i-1)+RNDM)
          Z = R1(3)-L_substep*COS(THETA)*(1.*(i-1)+RNDM)
          RTMP(1) = X
          RTMP(2) = Y
          RTMP(3) = Z
*     ... TRANSFORM TO MAIN EUSO SYSTEM FRAME ...
          X = X*1000            ! in m
          Y = Y*1000            ! in m
          Z = (Z-R_EARTH)*1000  ! in m 
*     ... PHOTON WAVELENGTH ...
          CALL CHERENKOV_SPECTRUM(w)
          ATTENUATION_CHERENKOV = GETTRANSITION(TRANS,w)
          RNDM = ESAFRNDM()
          IF(RNDM.GT.ATTENUATION_CHERENKOV) GOTO 222
          CN = CN + 1
*     ... RADIAL DISTANCE OF THE PHOTON IMPACT POINT ON THE FIRST ...
*     ... FRESNEL LENS SURFACE                                    ...
          CALL SURFACE_POINT(RIMPACT1,ALPHAIMPACT1)
*     ... PREPARE ESAF OUTPUT: ...
          CXshower(CN) = X
          CYshower(CN) = Y
          CZshower(CN) = Z
          CXfocal(CN)  = RIMPACT1*COS(ALPHAIMPACT1/180*PI)
          CYfocal(CN)  = RIMPACT1*SIN(ALPHAIMPACT1/180*PI)
          CZfocal(CN)  = 0
          Ctheta1(CN)  = theta1c
          Cphi1(CN)    = phi1c
          Clambda(CN)  = w
          ch_angle = 1./(1.+REFRACTIVE_INDEX(RTMP(1),RTMP(2),RTMP(3)))
          ch_angle=ACOS(ch_angle)
          time_sigma = 10./3*L*ch_angle*tan(THETA)
          time_corrected = ESAFGAUS(DBLE(time_ch),DBLE(time_sigma))
          Ctime(CN)    = time_corrected
          k_bunch = k_bunch+1
          IF(k_bunch.EQ.2000) THEN
            WRITE(6,200) '.' 
            k_bunch=0
          ENDIF
 222    ENDDO
 3      CONTINUE
        IF(FN.EQ.0.AND.CN.EQ.0.AND.avoid_cycling.GT.kCYCLING) GOTO 33
      ENDDO

 33   IF(FN.GT.0.OR.CN.GT.0) KEY_TRIG = .TRUE.
      IF(.NOT.KEY_TRIG) WRITE(6,*) '... FAILED. TRY AGAIN'
      WRITE(6,*)
 100  RETURN
 200  FORMAT($,A)
      END
      
      SUBROUTINE ESAF_RESET
#include "esafoutput.inc"
*     ... RESET COMMON BLOCKS
      FN = 0
      CN = 0
      SN = 0
      ShowerEnergy=0
      ShowerTheta=0
      ShowerPhi=0
      ShowerX1=0
      ShowerXmax = 0
      ShowerAgeEarth=0
      DO i = 1, 3
        ShowerRint(i)   = 0.
        ShowerImpact(i) = 0.
        ShowerRmax(i)   = 0.
      ENDDO
*
      DO i = 1, Nmax
*     ... FLUORESCENCE BLOCK
        FXshower(i) = 0.
        FYshower(i) = 0.
        FZshower(i) = 0.
        FXfocal(i)  = 0.
        FYfocal(i)  = 0.
        FZfocal(i)  = 0.
        Ftheta1(i)  = 0.
        Fphi1(i)    = 0.
        Flambda(i)  = 0.
        Ftime(i)    = 0.
*     ... CHERENKOV BLOCK
        CXshower(i) = 0.
        CYshower(i) = 0.
        CZshower(i) = 0.
        CXfocal(i)  = 0.
        CYfocal(i)  = 0.
        CZfocal(i)  = 0.
        Ctheta1(i)  = 0.
        Cphi1(i)    = 0.
        Clambda(i)  = 0.
        Ctime(i)    = 0.
      ENDDO
      DO i = 1, NSh
         ShowerXi(i) = 0
         ShowerXf(i) = 0
         ShowerRxi(i) = 0
         ShowerRyi(i) = 0
         ShowerRzi(i) = 0
         ShowerRxf(i) = 0
         ShowerRyf(i) = 0
         ShowerRzf(i) = 0
         ShowerTimei(i) = 0
         ShowerTimef(i) = 0
         ShowerAgei(i)  = 0
         ShowerAgef(i)  = 0
         ShowerNe(i)    = 0
      ENDDO
      END
