// ESAF : Euso Simulation and Analysis Framework
// Simulation module factory
// $Id: SimuModuleFactory.hh 1002 2004-09-13 16:44:02Z thea $
// A. Thea created Mar, 13 2004

#ifndef __SIMUMODULEFACTORY_HH_
#define __SIMUMODULEFACTORY_HH_

#include "euso.hh"
#include <string>
#include <vector>

class SimuModule;

class SimuModuleFactory {
public:
    // ctor
    SimuModuleFactory(const string&);

    // dtor
    virtual ~SimuModuleFactory();

    // get modules: NULL when all modules are done
    SimuModule *GetModule();

private:
    // physically build the modules
    void MakeModule(const string& mName);
    void MakeSequence(const string& mName);

    // modules and sequences
    vector<SimuModule*> fModules;

    // current module counter used in Get()
    size_t fCurrent;

    ClassDef(SimuModuleFactory,0)
};

#endif  /* SIMUMODULEFACTORY_HH_ */

