// ESAF : Euso Simulation and Analysis Framework
// Simunstruction test module
// $Id: TestSimuModule.hh 1112 2004-09-28 12:10:53Z thea $
// A. Thea created Mar, 13 2004

#ifndef __TESTRECOMODULE_HH_
#define __TESTRECOMODULE_HH_

#include "euso.hh"
#include "SimuModule.hh"

class SimuEvent;

class TestSimuModule : public SimuModule {
public:
    // ctor 
    TestSimuModule(const string&);

    // dtor
    virtual ~TestSimuModule();
    
    // Init method: called at the beginning of a run
    virtual bool Init();

    // called before each event process
    virtual bool PreProcess();

    // event processing
    virtual bool Process();

    // called after processing an event
    virtual bool PostProcess();

    // called at the end of each run
    virtual bool Done();

    // user memory clean
    virtual void UserMemoryClean();

    EsafConfigClass(Simu,TestSimuModule)

private:
    string fName;

    ClassDef(TestSimuModule,0)
};

#endif  /* __EUSORECOMODULE_HH_ */

