// ESAF : Euso Simulation and Analysis Framework
// $Id: EEventTruthAdder.cc 2666 2006-04-12 09:46:25Z moreggia $
// Alessandro Thea created Nov, 23 2003

#include "EEventTruthAdder.hh"
#include "ETruth.hh"
#include "MCTruth.hh"

ClassImp(EEventTruthAdder)

//______________________________________________________________________________
EEventTruthAdder::EEventTruthAdder( MCTruth *truth )
: EFiller( "ETruth" ) {
    // ctor
    
	fTruth = truth;
}

//______________________________________________________________________________
EEventTruthAdder::~EEventTruthAdder() {
    // dtor
    
}

//______________________________________________________________________________
void EEventTruthAdder::Fill( EFillable* f ) {
    // filler
	
    ETruth *truth = (ETruth*)f;

    truth->SetTrueEnergy( fTruth->GetEnergy() );
    truth->SetTrueTheta( fTruth->GetTheta() );
    truth->SetTruePhi( fTruth->GetPhi() );
    truth->fTrueParticleName  = fTruth->GetParticleName().c_str();
    truth->fTrueParticleCode  = fTruth->GetParticleCode();
    truth->SetTrueInitPos( fTruth->GetInitPos() );
    truth->SetTrueX1( fTruth->GetX1() );
    truth->SetTrueEarthImpact( fTruth->GetEarthImpact() );
    truth->SetTrueTOAImpact( fTruth->GetTOAImpact() );
    truth->SetTrueEarthAge(fTruth->GetEarthAge() );
    truth->SetTrueShowerMaxPos( fTruth->GetShowerMaxPos() );
    truth->SetTrueShowerXMax( fTruth->GetShowerXMax() );
    truth->SetTrueHclouds(fTruth->GetHclouds());
    truth->SetTrueCloudsthick(fTruth->GetCloudsthick());
    truth->SetTrueCloudsOD(fTruth->GetCloudsOD());
    truth->SetTrueLatitude(fTruth->GetLatitude());
    truth->SetTrueLongitude(fTruth->GetLongitude());
    truth->SetTrueDate(fTruth->GetDate());
    truth->SetTrueHGround(fTruth->GetHGround());
    truth->SetTrueGroundAlbedo(fTruth->GetGroundAlbedo());
    truth->SetTrueGroundSpecular(fTruth->GetGroundSpecular());
}
