// ESAF : Euso Simulation and Analysis Framework
// $Id: MeteoriteGenerator.hh 1435 2005-01-24 09:24:06Z moreggia $
// Alessandro Thea created Nov, 23 2003

#ifndef __METEORITEGENERATOR_HH_
#define __METEORITEGENERATOR_HH_

#include "euso.hh"
#include "EventGenerator.hh"

class MeteoriteTrack;
class MCTruth;

class MeteoriteGenerator : public EventGenerator {
public:
    // ctor
    MeteoriteGenerator();

    // dtor
    virtual ~MeteoriteGenerator();

    // get a new event 
    virtual PhysicsData *Get();

    // get pointer to MonteCarlo Truth
    virtual MCTruth *GetTruth();
    
    // get ready for next event
    virtual void Reset() {}   //FIXME : MUST BE IMPLEMENTED
 	
    EsafConfigClass(Generators, MeteoritesGenerator)

private:
    MeteoriteTrack *fTrack;
    MCTruth *fTruth;

    ClassDef(MeteoriteGenerator,0)
};

#endif  /* __METEORITEGENERATOR_HH_ */

