// ESAF : Euso Simulation and Analysis Framework
// $Id: Meteoroid.cc 756 2004-06-15 18:01:25Z thea $
//  created Dec,  4 2003

#include "Meteoroid.hh"

ClassImp(Meteoroid)

// ctor
// description of a meteoroid with mass, density, initial velocity and 
// position, heat of ablation and heat transfer coefficiencts
Meteoroid::Meteoroid( double mass, double density, const EVector& v, 
                      const EVector& x,double heat_abla, double heat_transf) {
    fMass = mass;
    fDensity = density;
    fVelocity = v;
    fPosition = x;
    fHeatAbla = heat_abla;
    fHeatTransf = heat_transf;
}

// dtor
Meteoroid::~Meteoroid() {
}

// get meteoroid radius
double Meteoroid::GetRadius() const {
    return TMath::Power((3.*GetMass())/(4.*GetDensity() * TMath::Pi() ),(1./3.));
}
