// ESAF : Euso Simulation and Analysis Framework
// $Id: UnisimFileShowerGenerator.hh 2529 2006-03-03 11:16:11Z thea $
// sergio bottai created Jan, 22 2004

#ifndef __UNISIMFILESHOWERGENERATOR_HH_
#define __UNISIMFILESHOWERGENERATOR_HH_

#include "euso.hh"
#include "EventGenerator.hh"
#include "EsafMsgSource.hh"
#include "Config.hh"
#include "ShowerTrack.hh"
class PhysicsData;
class ShowerTrack;
class MCTruth;

class UnisimFileShowerGenerator : public EventGenerator, public EsafMsgSource  {
public:
    // ctor
    UnisimFileShowerGenerator();

    // dtor
    ~UnisimFileShowerGenerator();

    // get a new event
    PhysicsData *Get();

    // get pointer to MonteCarlo Truth
    MCTruth *GetTruth();
    virtual void ReplaceInputFile( const char* );
    
    // get ready for next event
    virtual void Reset() {}  //FIXME : to be implemented

    void Open();
    void Close();

    EsafConfigClass(Generators, UnisimFileShowerGenerator)    

private:

    ShowerTrack *fTrack;
    ShowerStep  fStep;
    FILE* fFile;
    MCTruth *fTruth;
    string fFileName;
    map<string,double> fHeader;
    bool LoadTrack(Int_t) ;
    bool LoadHeader() ; 
    void LoadTruth(); 
    int fFirstEvent;              // this is the first event to read. All previous will be skipped
    int fCurrentEvent;            // this is the current event to read.  
    ClassDef(UnisimFileShowerGenerator,0)
};

#endif  /* __UNISIMFILESHOWERGENERATOR_HH_ */

