// ESAF : Euso Simulation and Analysis Framework
// $Id: FileShowerGenerator.cc 754 2004-06-15 17:49:45Z thea $
// Alessandro Thea created Nov, 23 2003

#include "FileShowerGenerator.hh"
#include "MCTruth.hh"
#include "ShowerTrack.hh"

ClassImp(FileShowerGenerator)

// ctor
FileShowerGenerator::FileShowerGenerator(): EventGenerator("file"),
                                            fTrack(0), fTruth(0) {
}

// dtor
FileShowerGenerator::~FileShowerGenerator() {
    if(fTrack) delete fTrack;
    if(fTruth) delete fTruth;
    fTrack = 0;
    fTruth = 0;
}

// get a new event
PhysicsData* FileShowerGenerator::Get() {
	return fTrack;
}

// get pointer to MonteCarlo Truth
MCTruth* FileShowerGenerator::GetTruth() {
	return fTruth;
}
