// ESAF : Euso Simulation and Analysis Framework
// $Id: FileLightSource.hh 2604 2006-03-20 21:51:35Z thea $
// D. De Marco - M. Pallavicini created Jan, 20 2002

#ifndef __FILELIGHTSOURCE_HH_
#define __FILELIGHTSOURCE_HH_

#include "euso.hh"
#include "LightSource.hh"

class FileLightSource : public LightSource {
public:
    // ctor
    FileLightSource();

    // dtor
    virtual ~FileLightSource();
   
    // generate photons 
    virtual PhotonsInAtmosphere* Get( const PhysicsData* );
    
    // get ready fo next event
    virtual void Reset() {}  //TOFIX : to be implemented

    // release all the mem hold in the buffers
    virtual Bool_t ClearMemory() { return kTRUE; }
    
    EsafConfigClass(LightSource,FileLightSource)
private:

    ClassDef(FileLightSource,0)
};

#endif  /* __FILELIGHTSOURCE_HH_ */

