// ESAF : Euso Simulation and Analysis Framework
// $Id: LightningLightSource.hh 2604 2006-03-20 21:51:35Z thea $
// D. De Marco - M. Pallavicini created Jan, 20 2002

#ifndef __LIGHTNINGLIGHTSOURCE_HH_
#define __LIGHTNINGLIGHTSOURCE_HH_

#include "euso.hh"
#include "LightSource.hh"

class LightningLightSource : public LightSource {
public:
	// ctor
    LightningLightSource();

	// dtor
    virtual ~LightningLightSource();
    
	// generate photons
    virtual PhotonsInAtmosphere* Get( const PhysicsData* );

    // get ready fo next event
    virtual void Reset() {}  //TOFIX : to be implemented

    // release all the mem hold in the buffers
    virtual Bool_t ClearMemory() { return kTRUE; }
    
    EsafConfigClass(LightSource,LightningLightSource)
		
private:

    ClassDef(LightningLightSource,0)
};

#endif  /* __LIGHTNINGLIGHTSOURCE_HH_ */

