// $Id: NoLightSource.hh 2604 2006-03-20 21:51:35Z thea $
// Author: Sylvain Moreggia   2005/11/10

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: NoLightSource                                                        *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __NOLIGHTSOURCE_HH__
#define __NOLIGHTSOURCE_HH__

#include "euso.hh"
#include "LightSource.hh"
#include "EmptyPhotonsInAtmosphere.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// NoLightSource                                                              //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class NoLightSource : public LightSource {
public:
    NoLightSource();
    virtual ~NoLightSource();
    virtual PhotonsInAtmosphere* Get( const PhysicsData* ) {return fEmpty;}
    virtual MCTruth* Truth() {return (MCTruth*)0;}
    
    // get ready for next event
    virtual void Reset() {}

    // release all the mem hold in the buffers
    virtual Bool_t ClearMemory() { return kTRUE; }

private:
    
    EmptyPhotonsInAtmosphere* fEmpty;

    ClassDef(NoLightSource,0)
};

#endif  /* __NOLIGHTSOURCE_HH__ */

