// ESAF : Euso Simulation and Analysis Framework
// $Id: SimpleCrkCalculator.hh 2676 2006-04-28 15:22:49Z moreggia $
// Anne Stutz created Apr, 27 2004

#ifndef __SIMPLECRKCALCULATOR_HH_
#define __SIMPLECRKCALCULATOR_HH_

#include "euso.hh"
#include "CrkCalculator.hh"
#include <TF12.h>
#include <TH1F.h>

class SimpleCrkCalculator : public CrkCalculator {
public:
    // ctor
    SimpleCrkCalculator();

    // dtor
    virtual ~SimpleCrkCalculator();

    // get ready for next event
    virtual void Reset() {}

    // get the yield of the Cerenkov emission 
    virtual Double_t GetCrkYield(const Double_t SC_alt, const Double_t SC_energy, Bool_t thr = true) const;

    // get the yield of the Cerenkov emission for an energy distribution
    virtual Double_t GetCrkYield(const Double_t SC_alt, TF12* EnergyDistribution) const;

    // get the yield of the Cerenkov emission
    virtual Double_t GetCrkYield(const Double_t SC_alt, const TH1F* EnergyDistribution) const;

    // get the wavelenght spectrum of the cerenkov emission
    virtual EsafSpectrum* GetCrkSpectrum() const;

    // get the energy threshold
    virtual Double_t GetEnergyThreshold(const Double_t SC_alt) const;

private:

    ClassDef(SimpleCrkCalculator,0)
};

#endif  /* __SIMPLECRKCALCULATOR_HH_ */

