// ESAF : Euso Simulation and Analysis Framework
// $Id: LightToEuso.cc 2695 2006-05-27 19:09:42Z moreggia $
// Marco Pallavicini created Mar, 13 2002

#include "LightToEuso.hh"
#include "EventGenerator.hh"
#include "RadiativeTransfer.hh"
#include "LightSource.hh"
#include "Atmosphere.hh"

ClassImp(LightToEuso)

//______________________________________________________________________________
LightToEuso::LightToEuso(const string& name) : EsafConfigurable(), EsafMsgSource(), fGenerator(0), 
                                               fLight(0), fRadiative(0) {
    //
    // ctor
    //
    fName = name;
}

//______________________________________________________________________________
LightToEuso::~LightToEuso() {
    //
    // dtor
    //
    SafeDelete(fGenerator);
    SafeDelete(fLight);
    SafeDelete(fRadiative);
    Atmosphere::Delete();
}

//______________________________________________________________________________
void LightToEuso::Reset() {
    //
    // get ready for next event. Reset method of every imbricated object is called.
    //
    
    Atmosphere::Reset();  // has an effect in random mode only
    Atmosphere::Get()->ResetClouds();
    Atmosphere::Get()->ResetAerosol();
    if(fGenerator) fGenerator->Reset();
    if(fLight) fLight->Reset();
    if(fRadiative) fRadiative->Reset(); 
}
