// ESAF : Euso Simulation and Analysis Framework
// $Id: FastRadiativeProcessesCalculator.hh 2764 2006-11-15 14:15:25Z moreggia $
// Sylvain Moreggia created Jan, 29 2004

#ifndef __FASTRADIATIVEPROCESSESCALCULATOR_HH_
#define __FASTRADIATIVEPROCESSESCALCULATOR_HH_

#include "euso.hh"
#include "RadiativeProcessesCalculator.hh"

class EsafDirection;
class BunchOfPhotons;
class SinglePhoton;

class FastRadiativeProcessesCalculator : public RadiativeProcessesCalculator {
public:
    // ctor
    FastRadiativeProcessesCalculator();

    // dtor
    virtual ~FastRadiativeProcessesCalculator();
        
    // Total transmission between photon position and finalpos (EUSO() by default)
    virtual Double_t Trans(const SinglePhoton&, const EarthVector& finalpos, Double_t* dummy=0) const;
    
    // Total transmission between bunch and a final position
    virtual Double_t Trans(const BunchOfPhotons&,const EarthVector&,vector<Double_t*>&) const;

    // Generate a random rayleigh-scattering position expressed in grammage
    Double_t RandomGrammage_RaylScat(Double_t Wl) const;

    // Generate a random Ozone absorption position
    Int_t RandomOzoneAbsorbPosition(const EarthVector&,const EarthVector&,Double_t, EarthVector&, Double_t) const;

    // get ready for next event
    void Reset() {}

private:

    ClassDef(FastRadiativeProcessesCalculator,0)
};

#endif  /* __FASTRADIATIVEPROCESSESCALCULATOR_HH_ */

