// $Id: NoCloudsPropagator.hh 1717 2005-04-14 16:39:27Z moreggia $
// Author: Sylvain Moreggia   2005/04/13

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: NoCloudsPropagator                                                           *
 *  Package: RadiativeTransfer                                                   *
 *  Coordinator: Moreggia S.                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __NOCLOUDSPROPAGATOR_HH__
#define __NOCLOUDSPROPAGATOR_HH__

#include "euso.hh"
#include "InCloudsPropagator.hh"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// NoCloudsPropagator                                                                 //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class NoCloudsPropagator : public InCloudsPropagator {
public:
    NoCloudsPropagator();
    virtual ~NoCloudsPropagator();

    // Transport a BunchOfPhotons in cloudy conditions,
    // generating SinglePhotons all along the travel (filling ListPhotonsInAtmosphere)
    inline virtual Medium Go(BunchOfPhotons&,ListPhotonsInAtmosphere&) const {Msg(EsafMsg::Warning) << "NoCloudsPropagator should not be called" << MsgDispatch; return NONE;}
     
    // get ready for next event
    inline virtual void Reset() {}
    

private:

    ClassDef(NoCloudsPropagator,0)
};

#endif  /* __NOCLOUDSPROPAGATOR_HH__ */

