// $Id: NoRadiativeTransfer.hh 2604 2006-03-20 21:51:35Z thea $
// Author: Sylvain Moreggia   2005/11/10

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: NoRadiativeTransfer                                                  *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __NORADIATIVETRANSFER_HH__
#define __NORADIATIVETRANSFER_HH__

#include "euso.hh"
#include "RadiativeTransfer.hh"

class ListPhotonsInAtmosphere;
class EmptyPhotonsOnPupil;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// NoRadiativeTransfer                                                        //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class NoRadiativeTransfer : public RadiativeTransfer {
public:
    NoRadiativeTransfer();
    virtual ~NoRadiativeTransfer();
    
    // Transfers atmospheric photons until EUSO pupil
    virtual PhotonsOnPupil *Get( PhotonsInAtmosphere*,const DetectorGeometry* dg );
    
    // copy of detector geometry defined in Detector part 
    virtual void CopyDetectorGeometry(const DetectorGeometry* dg) {}
    
    // get ready for next event
    // NB: fGround must be reset by child classes
    virtual void Reset() {}

    // release all the memoty hold in the buffers
    Bool_t ClearMemory() { return kTRUE; } 
private:
    ListPhotonsInAtmosphere* fTotalList;  // pointer on the list created by LightSource module
                                          // _must not be reset nor deleted_ by the present class
    
    EmptyPhotonsOnPupil* fEmpty;
    
    ClassDef(NoRadiativeTransfer,0)
};

#endif  /* __NORADIATIVETRANSFER_HH__ */

