// ESAF : Euso Simulation and Analysis Framework
// $Id: ClearSkyPropagator.cc 1435 2005-01-24 09:24:06Z moreggia $
// Sylvain Moreggia created Jun,  1 2004

#include "ClearSkyPropagator.hh"
#include "RadiativeProcessesCalculator.hh"
#include "RadiativeFactory.hh"

ClassImp(ClearSkyPropagator)

//_____________________________________________________________________________
ClearSkyPropagator::ClearSkyPropagator() : BunchPropagator() {
    //
    // ctor (should not be used)
    //
    fCalcul = RadiativeFactory::Get()->GetRadiativeProcessesCalculator();
    if(!fCalcul) Msg(EsafMsg::Panic) << "Memory allocation pb when building RadiativeProcessesCalculator" << MsgDispatch;
}

//_____________________________________________________________________________
ClearSkyPropagator::ClearSkyPropagator(const Ground* g) : BunchPropagator(g){
    //
    // ctor, copy RadiatvieTransfer ground description
    //
    fCalcul = RadiativeFactory::Get()->GetRadiativeProcessesCalculator();
    if(!fCalcul) Msg(EsafMsg::Panic) << "Memory allocation pb when building RadiativeProcessesCalculator" << MsgDispatch;
}

//_____________________________________________________________________________
ClearSkyPropagator::~ClearSkyPropagator() {
    //
    // dtor
    //
    SafeDelete(fCalcul);
}
