// $Id: Ground.cc 2679 2006-05-03 08:28:58Z moreggia $
// Author: S.Moreggia   Oct, 27 2003

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: Ground                                                               *
 *  Package: RadiativeTransfer                                               *
 *  Coordinator: Sylvain Moreggia                                            *
 *                                                                           *
 *****************************************************************************/
//_____________________________________________________________________________
//   Interface for ground description                                           //
//   ================================
//
//BEGIN_HTML <!--
/* -->
<!--*/
// -->END_HTML
// 

#include "Ground.hh"
#include "BunchOfPhotons.hh"

using namespace sou;

ClassImp(Ground)

//______________________________________________________________________________
Ground::Ground() : EsafConfigurable(), EsafMsgSource() {
    //
    // ctor
    //
}

//______________________________________________________________________________
Ground::~Ground(){
    //
    // dtor
    //
}

//______________________________________________________________________________
Bool_t Ground::IsUnderGround(const EarthVector& pos) const {
    //
    // to know if position is underground
    //
    Bool_t rtn(false);
    if(pos.IsUnderSeaLevel()) rtn = true;
    else rtn = (pos.Zv() < (Altitude(pos) - kAltitudeTolerance)) ? true : false;
    
    return rtn;
}
