#!/bin/ksh
if [ $# -lt 2 ]
then
   echo "Submit : Not enough parameters. Syntax is ..."
   echo "      "
   echo "          prod.sh [task] [events]"
   echo "      "
   exit 1
fi
task=`echo $1 | tr '[A-Z]' '[a-z]'`
events=`echo $2 | tr '[A-Z]' '[a-z]'`
ESAFHOME=$HOME/esaf/
PRODDIR=$ESAFHOME/production
suffix1=`eval date +%Y`
suffix2=`eval date +%m`
suffix3=`eval date +%d`
suffix4=`eval date +%H`
suffix5=`eval date +%M`
suffix6=`eval date +%S`
suffix=$suffix1.$suffix2.$suffix3.$suffix4.$suffix5.$suffix6
WORKDIR=/afs/in2p3.fr/group/eusof/euso_6/prod.$suffix
OUTFILE=$task.$suffix
mkdir $WORKDIR
cd    $WORKDIR
cp    $ESAFHOME/bin/i686/Euso .
cp -r $ESAFHOME/auxilar .
cp -r $ESAFHOME/config  .
cp -r $ESAFHOME/lib     .
cp -r $PRODDIR/slast/process-slast process-slast.template
sed -e "s%sed_OUTFILE%${OUTFILE}%; \
    s%sed_WORKDIR%${WORKDIR}%;     \
    s/sed_EVENTS/${events}/" process-slast.template > process-slast
chmod 755 process-slast
qsub -l platform=LINUX,hpss,t=140000 -me process-slast
