#!/bin/ksh
if [ $# -lt 3 ]
then
   echo "Submit : Not enough parameters. Syntax is ..."
   echo "      "
   echo "          submit [inpath] [infile] [events]"
   echo "      "
   exit 1
fi
inpath=`echo $1 | tr '[A-Z]' '[a-z]'`
infile=`echo $2 | tr '[A-Z]' '[a-z]'`
events=`echo $3 | tr '[A-Z]' '[a-z]'`
ESAFHOME=$HOME/esaf/
PRODDIR=$ESAFHOME/production/unisim/
suffix1=`eval date +%Y`
suffix2=`eval date +%m`
suffix3=`eval date +%d`
suffix4=`eval date +%H`
suffix5=`eval date +%M`
suffix6=`eval date +%S`
suffix=$suffix1.$suffix2.$suffix3.$suffix4.$suffix5.$suffix6
WORKDIR=/afs/in2p3.fr/group/eusof/euso_1/prod.$suffix
mkdir $WORKDIR
cd    $WORKDIR
cp    $ESAFHOME/bin/i686/Euso .
cp -r $ESAFHOME/auxilar .
cp -r $ESAFHOME/config  .
cp -r $ESAFHOME/lib     .
cp -r $PRODDIR/process-unisim process-unisim.template
sed -e "s%sed_INFILE%${infile}%; \
    s%sed_WORKDIR%${WORKDIR}%;   \
    s/sed_EVENTS/${events}/" process-unisim.template > process-unisim
chmod 755 process-unisim
qsub -l platform=LINUX,hpss,t=140000 -me process-unisim 
